program Autopick_boundary 
  !Input fatten_bound and it will track the inner and outer boundaries  Jesse Lomask 10/04/05
  !Store the x, y, norm, distance
  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod3d
  use pick_mod

  implicit none

  integer				::nt, nx, ny, non_zero_mask,istatus,bnd_index
  integer				::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft
  integer                               ::radius,irx,irt
  integer                               ::diag_count, adj_count, ix_diag, it_diag, ix_new, it_new
  integer                               ::ix_old, it_old,pick_count,which_bound
  real::o1,o2,o3,d1,d2,d3,maxdat,mindat,rangedat,cutoff,dist
  real, pointer, dimension(:,:)	        ::horizon_out,mask_out
  real, pointer, dimension(:,:,:)	::data, norm_d,mask_in,inner_bnd,outer_bnd
  real                                  ::mask_val1,mask_val2
!!$  real, dimension(:,:,:)                ::box_grid,box_grid_colx,box_grid_coly,box_grid_row,box_grid_bnds


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

!!$  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_history("o1",o1); call from_history("o2",o2); call from_history("o3",o3);
  call from_history("d1",d1); call from_history("d2",d2); call from_history("d3",d3);

  call from_param("cutoff",cutoff,0.)
  call from_param("which_bound",which_bound,0)
  ! ALLOCATE INPUT DATA AND MASK
  allocate(data(nt,nx,ny),mask_in(nt,nx,ny),mask_out(nt,nx),horizon_out(nt*nx,2))

  ! READ INPUT DATA
  call sep_read(data)

  ! READ IN INPUT MASK
  mask_in=1.
  if (exist_file("mask_in")) call sreed("mask_in", mask_in, 4*nt*nx) 

  write(0,*) maxval(data),minval(data),nt,nx,ny

  write(0,*) 'making mask'
  mask_out=0.
  !  cutoff=.00065



  find_seed: do ix=1,nx
     do it=1,nt
        ! SCAN FOR SEED POINT, A BOUND HAS ONE OF ITS FOUR ADJACENT SIDES TOUCHING OUTSIDE OF THE BOUNDARY
        if (isbound(data,mask_in,it,nt,ix,nx,which_bound)) then

           ! FIND END
           ! AN END HAS JUST ONE ADJACENT BOUNDARY POINT
           ! DIAGONALS ARE BETTER THAT ADJACENTS
           ! COUNT NUMBER OF
           diag_count=0
           adj_count=0
           do ix_diag=-1,1
              do it_diag=-1,1
                 it_new=it+it_diag; ix_new=ix+ix_diag
                 if (it_new>=1.and. it_new<=nt.and.ix_new>=1..and.ix_new<=nx) then
                    if (ix_diag*it_diag==0) then
                       if (ix_diag+it_diag/=0) then
                          if (isbound(data,mask_in,it_new,nt,ix_new,nx,which_bound)) adj_count=adj_count+1
                       end if
                    else
                       if (isbound(data,mask_in,it_new,nt,ix_new,nx,which_bound)) diag_count=diag_count+1
                    end if
                 end if
              end do
           end do
           if (diag_count+adj_count<=1) then
              write(0,*) 'ix',ix,'it',it
              if (diag_count+adj_count==0) then
                 cycle find_seed
              end if
              exit find_seed
           end if

        end if

!!$
     end do
  end do find_seed

  write(0,*) 'ix',ix,'it',it
  pick_count=1
  horizon_out(pick_count,1)=it
  horizon_out(pick_count,2)=ix
  mask_out(it,ix)=pick_count

  ! NOW THAT WE HAVE AN END POINT...JUST STEP THROUGH PREFERING DIAGONALS OVER ADJACENTS
  it_old=0;  ix_old=0
  track: do 
     ! LOOK AT DIAGONALS
     xbox1: do ix_diag=-1,1
        ybox1: do it_diag=-1,1
           it_new=it+it_diag; ix_new=ix+ix_diag
           inbounds1: if (it_new>=1.and. it_new<=nt.and.ix_new>=1..and.ix_new<=nx) then
              adjacent1:if (ix_diag*it_diag==0) then
                 !if (ix_diag+it_diag/=0) then 
                 !             if (isbound(data,mask_in,it_new,nt,ix_new,nx,0)) adj_count=adj_count+1
                 !do nothing
                 !end if
              else
                 if (isbound(data,mask_in,it_new,nt,ix_new,nx,which_bound)) then
                    if (it_new==it_old.and.ix_new==ix_old) then
                       ! do nothing
                    else
                       ! HAVE NEW VALUE

                       ix_old=ix; it_old=it
                       ix=ix_new; it=it_new
                       pick_count=pick_count+1
                       horizon_out(pick_count,1)=it
                       horizon_out(pick_count,2)=ix
                       mask_out(it,ix)=pick_count
                       write(0,*) 'newvalues', ix, it
                       cycle track
                    end if
                 end if
              end if adjacent1
           end if inbounds1
        end do ybox1

     end do xbox1
!!$
     ! LOOK AT ADJACENTS
     xbox2: do ix_diag=-1,1
        ybox2: do it_diag=-1,1
           it_new=it+it_diag; ix_new=ix+ix_diag
           inbounds2:if (it_new>=1.and. it_new<=nt.and.ix_new>=1..and.ix_new<=nx) then
              adjacent2: if (ix_diag*it_diag==0) then  ! IS ADJACENT
                 if (ix_diag+it_diag/=0) then  ! IS NOT CENTER
                    if (isbound(data,mask_in,it_new,nt,ix_new,nx,which_bound)) then ! IS BOUNDARY
                       if (it_new==it_old.and.ix_new==ix_old) then ! IS LAST VALUE
                          ! do nothing
                       else
                          ! HAVE NEW VALUE
                          ix_old=ix; it_old=it
                          ix=ix_new; it=it_new
                          write(0,*) 'newvalues', ix, it
                          pick_count=pick_count+1
                          horizon_out(pick_count,1)=it
                          horizon_out(pick_count,2)=ix
                          mask_out(it,ix)=pick_count

                          cycle track
                       end if
                    end if
                 else
                    ! do nothing
                    !     write(0,*) 'GOT STUCK', ix,iy
                    ! stop 
                 end if
              end if adjacent2
           end if inbounds2

        end do ybox2
     end do xbox2
     write(0,*) 'GOT STUCK', ix,iy
     exit track

  end do track

!!$boundary_out=0.
!!$boundary_out(1:,1:2)=horizon_out(1:,1:2)
!!$
!!$
!!$
!!$# CALCULATE THE NORM
!!$  do it=1, pick_count-1
!!$     ! DELTA T IS STORED IN THE X POSITION TO TAKE THE NORM
!!$     boundary_out(it,4)=-1*((boundary(it+1,1)-boundary(it,1)))
!!$     ! DELTA X IS STORED IN THE T POSITION
!!$     boundary_out(it,3)=boundary(it+1,2)-boundary(it,2)
!!$     write(0,*) boundary_out(it,1:)
!!$  end do
!!$
!!$  boundary_out(nt,4)= boundary_out(nt-1,4)
!!$  boundary_out(nt,3)= boundary_out(nt-1,3)
!!$
!!$  boundary_out_temp=boundary_out
!!$  write(0,*) 'smooothing'
!!$
!!$  ! SMOOTH THE NORMS
!!$  do it=2, nt-1
!!$     boundary_out(it,4)=sum(boundary_out_temp(it-1:it+1,4))/3
!!$     boundary_out(it,3)=sum(boundary_out_temp(it-1:it+1,3))/3
!!$     !   write(0,*) boundary_out(it,1:)
!!$  end do
!!$
!!$  ! SET THE BOUNDARIES
!!$  boundary_out(1,4)= boundary_out(2,4)
!!$  boundary_out(1,3)= boundary_out(2,3)
!!$  boundary_out(nt,4)= boundary_out(nt-1,4)
!!$  boundary_out(nt,3)= boundary_out(nt-1,3)
!!$
!!$
!!$  ! normalize
!!$  do it=1, nt
!!$     boundary_out(it,3:4)=boundary_out(it,3:4)/((boundary_out(it,3)**2+boundary_out(it,4)**2)**.5)
!!$     write(0,*) boundary_out(it,1:)
!!$  end do
!!$
!!$# CORRECT ORIENTATION OF THE NORM
!!$
!!$  do it=2,pick_count
!!$     inbnd: if (boundary(it,1)+boundary(it,3)>=1.and.boundary(it,1)+boundary(it,3)<=nt.and.boundary(it,2)+boundary(it,4)>=1.and.boundary(it,2)+boundary(it,4)<=nx) then
!!$        mask_val1=mask_in(nint(boundary(it,1)+boundary(it,3)),nint(boundary(it,2)+boundary(it,4)))
!!$        mask_val2=mask_in(nint(boundary(it,1)-boundary(it,3)),nint(boundary(it,2)-boundary(it,4)))
!!$
!!$        if (mask_val1==which_bound.and.mask_val2==1) then  ! SWITCH DIRECTIONS
!!$        boundary(it,3)=-1*boundary(it,3)
!!$        boundary(it,4)=-1*boundary(it,4)
!!$     elseif  (mask_val1==1.and.mask_val2==which_bound) then ! DO NOTHING
!!$
!!$     else
!!$        write(0,*) 'does not fit'
!!$        boundary(it,3)=boundary(it-1,3)
!!$        boundary(it,4)=boundary(it-1,4)
!!$
!!$     end if inbnd
!!$  else
!!$     boundary(it,3)=boundary(it-1,3)
!!$     boundary(it,4)=boundary(it-1,4)
!!$  end if inbnd
!!$end do
 
call to_history("n1",pick_count); call to_history("n2",2) 
call to_history("n3",1)
call to_history("d1",1); call to_history("d2",1 )
call to_history("d3",1 )
call to_history("o1",0.); call to_history("o2",0.)
call to_history("o3",0.)
call to_history("esize",4)
call sep_write(horizon_out(1:pick_count,1:))


call to_history("n1",nt,"mask_out") ; call to_history("n2",nx,"mask_out") 
call to_history("n3",ny,"mask_out")
call to_history("d1",d1,"mask_out"); call to_history("d2",d2,"mask_out")
call to_history("d3",d3,"mask_out")
call to_history("o1",o1,"mask_out"); call to_history("o2",o2,"mask_out")
call to_history("o3",o3,"mask_out")
call to_history("esize",4,"mask_out")
call sep_write(mask_out,"mask_out")





end program Autopick_boundary

