module inc
  use chain0_mod
  use igrad2_2d_reg
  use igrad3_epst
  use model_mask
  integer, save          :: ndata
  real, save,pointer, dimension(:)       :: temp1
contains
  subroutine flat_chain_init( ndat_in)
    integer ndat_in
    ndata = ndat_in				
    allocate( temp1(ndata))
  end subroutine flat_chain_init
  integer function flat_chain_exec( adj, add, model, data)
    integer       ::stat
    logical       :: adj, add
    real          :: data(:), model(:)
    call chain20( igrad2_2d_reg_lop,model_mask_lop,adj, add, model, data,temp1)
    flat_chain_exec=0
  end function flat_chain_exec
  subroutine flat_chain_close()
    deallocate(temp1)
  end subroutine flat_chain_close

  subroutine flat3_chain_init( ndat_in)
    integer ndat_in
    ndata = ndat_in				
    allocate( temp1(ndata))
  end subroutine flat3_chain_init
  integer function flat3_chain_exec( adj, add, model, data)
    integer       ::stat
    logical       :: adj, add
    real          :: data(:), model(:)
    call chain20( igrad3_epst_lop,model_mask_lop,adj, add, model, data,temp1)
    flat3_chain_exec=0
  end function flat3_chain_exec
  subroutine flat3_chain_close()
    deallocate(temp1)
  end subroutine flat3_chain_close
end module inc




program Dipintegrator_geo_prec
  !
  !  1/30/06  TIME DOMAIN INTEGRATION USING CONJAGATE GRADIENTS IN 3D, PRECONDITIONED ON THE HELIX
  !
  use sep
  use inc
  !use dipinteg_3D
  !use dipinteg_3D_slice
  !  use igrad3_period 
  use ztrans_mod
  use dipinteg_3D_2
  use triangle
  use igrad1
  use igrad2_2d
  use igrad2_3d
  use igrad1_3d
  use igrad1_2d
  use igrad1_2d_off
  use igrad2_2d_reg
  use igrad3
  use icai1
  use igrad2
  use leakint_2D
  use leakint2
  use leakint
  use dottest
  use igrad3_epst
  use fault_weight
  use solver_smp_mod
  use solver_prc_mod
  use solver_mod
  use weight_solver
  !  use eps_weight
  use model_mask
  use polydiv
  use lapfac
  use lapfac3
  use lapfac2d_2
  use helicon
  use chain0_mod

  ! use mad_routines
  ! use triangle1

  implicit none
  integer 	                             :: n1, n2, n3, iter,prec,bounds,slice,esize,stat1,iv,ik,min_niter
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,niter,ip,irls_index,i3,liter
  integer                                    ::linear_niter,movie_index,use_wt,na,k
  integer                                    ::ref_2,ref_3,irls,slice_width
  integer                                    ::i1,ext_indicator,iteration_counter
  integer                                    ::max_index,tau_cnt,change_cnt
  real                                       :: q,eps_t,eps_h,pi_var,eps_r,wt_iter
  real                                       ::d1,d2,d3,o1,o2,o3,previous_dtau
  real                                       ::res_scale,res_val,last_res,res_val_diff
  real                                       ::prev_tau_val,epsi
  type(filter)                                :: aa
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:,:),   allocatable    ::ztrans,ztrans2
  real, dimension (:,:,:),   allocatable    ::cos_trans
  real,    dimension (:),     allocatable    :: cos_wt,resid,rand_vec,rt_full,ww_bounds,ww_bounds_temp,max_array
  real,    dimension (:),     allocatable    ::corr_prev_tau,isotau, abs_tau
  real,    dimension(:),pointer              ::rt,hh,dtau,tau,tau_1st,tau_2nd,rt_new,rt_temp,init_rt,grad_tau,r0,r1
  real,    dimension (:,:),     allocatable  ::hh_2D,tau_slice,ref_array,tau_array
  real,    dimension (:,:),     allocatable  ::tau_2D,ww_2D_bounds,tau2D
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,px_new,px_dat
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3D,res_3D,rt_3D
  real,    dimension (:,:,:,:),   allocatable  ::ww_3D,ww_3D_bounds
  !TEMPORY PTERM STUFF
  real,    dimension (:,:), allocatable      ::p_sqr,p_sqr_dtau,p_sqr_dtau_sm,pterm_cor
  real,    dimension(:),pointer              ::rt_adj,pterm_cor_1D,filter,ww,res_div,res_rev,rt_adj2
  real,    dimension(:),allocatable           ::ww_slice
  integer, dimension (2)                :: n, rect
  real,    dimension  (2)   :: dot1,dot2
  real                                 ::upwt,downwt,p_tau_x,p_tau_y,stop_tol
  integer                                ::tau_1,tau_2
  real                                 ::dtau_dx,dtau_dy,shift_var
  real,    dimension (:,:), allocatable      ::px_2D_new,py_2D_new
  real,    dimension (:,:,:),   allocatable  ::px_3D,py_3D,initial_model_3d,model_mask_3d
  real,    dimension (:,:,:),   allocatable  ::p_sqr2,thrd_trm
  real,    dimension (:),   allocatable  ::p_sqr2_1D,thrd_trm_1D,thrd_trm_int
  real,    dimension(:), allocatable         ::tau_sample
  real,    dimension(:,:,:), allocatable         ::tau_sample_3D
  ! TEMPORARY VARIABLES
  real,    dimension (:), allocatable        ::dip_diff,dip_integ,px_1D
  real,    dimension (:,:), allocatable      ::dip_integ2D,dip_correction,initial_model_2d
  real,    dimension (:,:), allocatable      ::tau_grad,model_mask_2d
  real,    dimension (:), pointer        ::model_mask_1d,initial_model,initial_poly,model_poly,inv_model_mask_1d
  integer                                    ::iz,i,j

!!$  interface 
!!$     function flat_chain_exec(adj,add,model,data)
!!$       real,dimension(:) :: model,data
!!$       logical,intent(in) :: adj,add
!!$     end function flat_chain_exec
!!$  end interface

  call sep_init ()
  ! call from_history (n1,n2,n3,esize=4)
  !  call from_history ("esize",esize,8) 
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("eps_r",eps_r,1.)
  call from_param("prec",prec,0) ! 1 2D, 0 3D
  call from_param("bounds",bounds,2)
  call from_param("slice",slice,0)
  call from_param("ref_2",ref_2,1)
  call from_param("ref_3",ref_3,1)
  !  call from_aux ("dipx", n1,n2,n3,esize=4)
  call from_aux ("dipx", n1,n2,n3,esize=4)
  call from_history ("dipx",d1,1.)
  call from_history ("dipx",d2,1.)
  call from_history ("dipx",d3,1.)
  call from_history ("dipx",o1,0.)
  call from_history ("dipx",o2,0.)
  call from_history ("dipx",o3,0.)

  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)
  call to_history ("d1",d1)
  call to_history ("d2",d2)
  call to_history ("d3",d3)
  call to_history ("o1",o1)
  call to_history ("o2",o2)
  call to_history ("o2",o3)

  write(0,*) 'n1,n2,n3',n1,n2,n3
  call from_param("niter",niter,1)
  call from_param("min_niter",min_niter,1)
  call from_param("linear_niter",linear_niter,100)
  call from_param("wt_iter",wt_iter,1.)
  call from_param("irls",irls,0)
  call from_param("stop_tol",stop_tol,.0001)











  select case(prec)
  case(0) ! NO PRECONDITIONING

     ! READ IN DATA
     allocate(px(n1,n2,n3),py(n1,n2,n3))
     call sep_read(px,"dipx")
     call sep_read(py,"dipy")
     write(0,*) 'SUCCESSFULLY READ IN THE DIPS'



     !   allocate(ztrans(n1,2*n2,2*n3))
     !  call z_trans(n1,2*n2,2*n3,eps_t,eps_h,ztrans)
     allocate( rt( n1*n2*n3*3),rt_new(n1*n2*n3*3))
     rt=0.
     rt(n1*n2*n3+1:n1*n2*n3*2)=reshape(px,(/size(px)/))

     deallocate(px)
     rt(n1*n2*n3*2+1:3*n1*n2*n3)=reshape(py,(/size(py)/))

     deallocate(py)
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3),grad_tau(n1*n2*n3*3),ww(n1*n2*n3*2),tau_3D(n1,n2,n3),res_3D(n1,n2,n3))

     allocate(model_mask_3d(n1,n2,n3),model_mask_1d(n1*n2*n3),initial_model(n1*n2*n3),initial_model_3d(n1,n2,n3),inv_model_mask_1d(n1*n2*n3))
     write(0,*) 'past allocations'
     dtau=0.
     tau=0.


     initial_model=0.

     model_mask_3d=1.
!!$ 
!!$    model_mask_3d(1:,50,39)=0.
!!$
!!$     model_mask_3d(66,7,39)=0.
!!$     model_mask_3d(66,37,39)=0.
!!$     model_mask_3d(66,50,39)=0.
!!$     model_mask_3d(66,63,39)=0.
!!$     model_mask_3d(66,70,39)=0.
!!$     model_mask_3d(66,90,39)=0.
!!$     model_mask_3d(66,98,39)=0.

     model_mask_3d(1:,ref_2,ref_3)=0.
     model_mask_3d(63,1:,1:)=0.
!!$     model_mask_3d(66,7,5)=0.
!!$     model_mask_3d(66,37,5)=0.
!!$     model_mask_3d(66,50,5)=0.
!!$     model_mask_3d(66,63,5)=0.
!!$     model_mask_3d(66,70,5)=0.
!!$     model_mask_3d(66,90,5)=0.
!!$     model_mask_3d(66,98,5)=0.


!!$     model_mask_3d(63,50,10)=0.
!!$     model_mask_3d(63, 6,10)=0.
!!$     model_mask_3d(63,29,10)=0.
!!$     model_mask_3d(63,60,10)=0.  
!!$     model_mask_3d(63,83,10)=0
!!$     model_mask_3d(63,97,10)=0.





!!$     model_mask_3d(63 , 50 , 10  )  =0 
!!$     model_mask_3d(63 , 59 , 10  )=0   
!!$     model_mask_3d(63 , 79 , 10 )=0        
!!$     model_mask_3d(63 , 33 , 10 )=0     
!!$     model_mask_3d(63 , 4  , 10 )=0     
!!$     model_mask_3d(63 , 2  , 30 )=0    
!!$     model_mask_3d(63 , 22 , 30 )=0       
!!$     model_mask_3d(63 , 38 , 30 )=0       
!!$     model_mask_3d(63 , 52 , 30 )=0        
!!$     model_mask_3d(63 , 76 , 30 )=0      
!!$     model_mask_3d(63 , 93 , 30 )=0   
!!$     model_mask_3d(63 , 99 , 30 )=0        
!!$     model_mask_3d(63 ,  6 , 50 )=0       
!!$     model_mask_3d(63 , 35 , 50)=0        
!!$     model_mask_3d(63 , 51 , 50 )=0        
!!$     model_mask_3d(63 , 63 , 50 )=0       
!!$     model_mask_3d(63 , 82 , 50  )=0      
!!$     model_mask_3d(63 , 97 , 50   )=0     
!!$     model_mask_3d(63 ,  2 , 70  )=0      
!!$     model_mask_3d(63 , 35 , 70  )=0     
!!$     model_mask_3d(63 , 55 , 70   )=0     
!!$     model_mask_3d(63 , 62 , 70   )=0     
!!$     model_mask_3d(63 , 77 , 70   )=0      
!!$     model_mask_3d(63 , 94 , 70   )=0     
!!$
!!$
!!$
!!$
!!$     model_mask_3d(63,  40, 45 )=0
!!$     model_mask_3d(63,  36, 54 )=0 
!!$     model_mask_3d(63,  38, 61 )=0   
!!$     model_mask_3d(63,  39, 68 )=0     
!!$     model_mask_3d(63,  54, 77 )=0    
!!$     model_mask_3d(63,  45, 77 )=0     
!!$     model_mask_3d(63,  25, 77 )=0      












     !    model_mask_3di=1. ! TO TURN OFF MASK
     model_mask_1d=1.
     !model_mask_1d(n1*n2+1:n1*n2*2)=reshape(model_mask_2d,(/n1*n2/))
     model_mask_1d=reshape(model_mask_3d,(/n1*n2*n3/))
     !  model_mask_1d=1.
     write(0,*) 'eps',eps_t
    inv_model_mask_1d=1.-model_mask_1d
     if (exist_file("initial_model")) call sreed("initial_model", initial_model,4*n1*n2*n3)

     initial_model_3d=0.
     initial_model_3d=reshape(initial_model,(/n1,n2,n3/))
   

!!$     initial_model_3d(66,7,39)=29.
!!$     initial_model_3d(66,37,39)=17.
!!$     initial_model_3d(66,50,39)=0.  
!!$     initial_model_3d(66,63,39)=-16
!!$     initial_model_3d(66,70,39)=-18.
!!$     initial_model_3d(66,90,39)=-22.
!!$     initial_model_3d(66,98,39)=-9.
!!$
!!$     initial_model_3d(66,7,5)=29.
!!$     initial_model_3d(66,37,5)=17.
!!$     initial_model_3d(66,50,5)=0.  
!!$     initial_model_3d(66,63,5)=-16
!!$     initial_model_3d(66,70,5)=-18.
!!$     initial_model_3d(66,90,5)=-22.
!!$     initial_model_3d(66,98,5)=-9.

!!$     initial_model_3d(63,50,10)=0.
!!$     initial_model_3d(63, 6,10)=31. 
!!$     initial_model_3d(63,29,10)=22.
!!$     initial_model_3d(63,60,10)=-11.  
!!$     initial_model_3d(63,83,10)=-13
!!$     initial_model_3d(63,97,10)=-16.
!!$ 
!!$   initial_model_3d(63,50,10)=0.
!!$     initial_model_3d(63, 6,10)=21.  
!!$     initial_model_3d(63,29,10)=12.
!!$     initial_model_3d(63,60,10)=-1.  
!!$     initial_model_3d(63,83,10)=-3
!!$     initial_model_3d(63,97,10)=-6.




!!$     initial_model_3d(63 , 50 , 10  )  =0 
!!$     initial_model_3d(63 , 59 , 10  )=-12    
!!$     initial_model_3d(63 , 79 , 10 )=-14        
!!$     initial_model_3d(63 , 33 , 10 )=19     
!!$     initial_model_3d(63 , 4  , 10 )=31     
!!$     initial_model_3d(63 , 2  , 30 )=32    
!!$     initial_model_3d(63 , 22 , 30 )=27       
!!$     initial_model_3d(63 , 38 , 30 )=18       
!!$     initial_model_3d(63 , 52 , 30 )=-5        
!!$     initial_model_3d(63 , 76 , 30 )=-17      
!!$     initial_model_3d(63 , 93 , 30 )=-16   
!!$     initial_model_3d(63 , 99 , 30 )=0        
!!$     initial_model_3d(63 ,  6 , 50 )=33       
!!$     initial_model_3d(63 , 35 , 50)=21        
!!$     initial_model_3d(63 , 51 , 50 )=5        
!!$     initial_model_3d(63 , 63 , 50 )=-13       
!!$     initial_model_3d(63 , 82 , 50  )=-19      
!!$     initial_model_3d(63 , 97 , 50   )=-12     
!!$     initial_model_3d(63 ,  2 , 70  )=35       
!!$     initial_model_3d(63 , 35 , 70  )=22     
!!$     initial_model_3d(63 , 55 , 70   )=6     
!!$     initial_model_3d(63 , 62 , 70   )=-9      
!!$     initial_model_3d(63 , 77 , 70   )=-21      
!!$     initial_model_3d(63 , 94 , 70   )=-20     
!!$
!!$
!!$
!!$     initial_model_3d(63,  40, 45 )=18 
!!$     initial_model_3d(63,  36, 54 )=22 
!!$     initial_model_3d(63,  38, 61 )=21   
!!$     initial_model_3d(63,  39, 68 )=21     
!!$     initial_model_3d(63,  54, 77 )=10    
!!$     initial_model_3d(63,  45, 77 )=20     
!!$     initial_model_3d(63,  25, 77 )=28      


     !   initial_model_3d=0. ! TO TURN OFF INITIAL SOLUTION
     initial_model=reshape(initial_model_3d,(/n1*n2*n3/))
initial_model=initial_model*inv_model_mask_1d

     dtau=0.

     rt_new=rt

     call igrad3_epst_init(n1,n2,n3,eps_t)
     k=1
     na=20
     epsi=.1

     write(0,*) 'about to factor laplacian' 
     aa = lapfac3d(epsi,n1,n2,na,eps_t) ! REMOVED
     write(0,*) 'factored laplacian' 
     call polydiv_init(n1*n2*n3,aa) ! REMOVED
     call flat3_chain_init(n1*n2*n3)
     call model_mask_init(model_mask_1d)

     call dot_test (flat3_chain_exec,n1*n2*n3,n1*n2*n3*3,dot1,dot2)


     do iter=1,niter

        write(0,*) 'starting nonlinear loop number:',iter

        write(0,*) 'min dip',minval(rt_new)
        !       if (iter==1) then
        ! INITIALIZE RESIDUAL WITH INITIAL TAU    
        stat1=igrad3_epst_lop(.false.,.true.,-initial_model,rt_new)  !  r-grad (tau0)
        ! BEST WITHOUT PRECONDITIONING
        !      call solver_smp(dtau, rt_new,igrad3_epst_lop,cgstep,linear_niter,verb=.true.,Jop=model_mask_lop)
        !     call solver_smp(dtau, rt_new,igrad3_epst_lop,cgstep,linear_niter,verb=.true.)
!!$           ! BEST 
        call solver_prc(dtau, rt_new,flat3_chain_exec,polydiv_lop,cgstep,n1*n2*n3,linear_niter,0.,verb=.true.)
        ! call solver_smp(dtau, rt_new,flat3_chain_exec,cgstep,linear_niter,verb=.true.)
        ! FILL IN KNOWN MODEL POINTS
        !           dtau=dtau*model_mask_1d+initial_model 

        !       else 
        ! BEST WITHOUT PRECONDITIONING
        !           call solver_smp(dtau, rt,igrad3_epst_lop,cgstep,linear_niter,Jop=model_mask_lop,verb=.true.)
        !call solver_smp(dtau, rt_new,igrad3_epst_lop,cgstep,linear_niter,verb=.true.)
!!$           ! BEST
        !         stat1=igrad3_epst_lop(.false.,.true.,-initial_model,rt_new)  !  r-grad (tau0)

        !                   call solver_prc(dtau, rt_new,flat3_chain_exec,polydiv_lop,cgstep,n1*n2*n3,linear_niter,0.,verb=.true.)

        !   call solver_smp(dtau, rt_new,flat3_chain_exec,cgstep,linear_niter,verb=.true.)

        !    dtau=dtau*model_mask_1d+initial_model  ! Fill in known model points

        ! dtau=dtau*model_mask_1d
        !        end if

        call cgstep_close ()

        write(0,*) 'maximum dtau',maxval(dtau)
        write(0,*) 'minimum dtau',minval(dtau)

        tau=tau+dtau
        tau=tau*model_mask_1d+initial_model 

        !    call correct_dip_3D  (tau,rt,rt_new,n1,n2,n3,ref_2,ref_3)
        call p_at_tau (tau,rt,rt_new,n1,n2,n3,ref_2,ref_3)    !  p(tau)
        stat1=flat3_chain_exec(.false.,.false.,tau,grad_tau) !  grad_tau
        !  stat1=igrad3_epst_lop(.false.,.false.,tau,grad_tau)   !  grad_tau
        rt_new=rt_new-grad_tau                                !  p(tau)-grad_tau


     end do

     write(0,*) 'EPS_H OUT',eps_h

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call sep_write (tau) 

!!$     call sep_write (ww,"wt_out") 
!!$     call to_history ("n1",   n1,"wt_out")
!!$     call to_history ("n2",   n2,"wt_out")
!!$     call to_history ("n3",   n3*2,"wt_out")    
!!$     call to_history ("esize",4,"wt_out")
!!$
!!$     call sep_write (res_div,"res_div") 
!!$     call to_history ("n1",   n1,"res_div")
!!$     call to_history ("n2",   n2,"res_div")
!!$     call to_history ("n3",   n3,"res_div")    
!!$     call to_history ("esize",4,"res_div")
!!$
!!$     call to_history ("n1",   n1,"mod_movie")
!!$     call to_history ("n2",   n2,"mod_movie")
!!$     call to_history ("n3",   movie_index,"mod_movie")    
!!$     call to_history ("esize",4,"mod_movie")
!!$
!!$     call to_history ("n1",   n1,"res_movie")
!!$     call to_history ("n2",   n2,"res_movie")
!!$     call to_history ("n3",   movie_index,"res_movie")    
!!$     call to_history ("esize",4,"res_movie")
!!$
!!$     call to_history ("n1",   n2,"wt_movie")
!!$     call to_history ("n2",   n3*2,"wt_movie")
!!$     call to_history ("n3",   movie_index,"wt_movie")    
!!$     call to_history ("esize",4,"wt_movie")
!!$
!!$     call to_history ("n1",   n1,"resid")
!!$     call to_history ("n2",   n2,"resid")
!!$     call to_history ("n3",   n3*2,"resid")    
!!$     call to_history ("esize",4,"resid")
!!$     call sep_write (rt_new,"resid") 
!!$     call to_history ("n1",   n1,"res_cube_movie")
!!$     call to_history ("n2",   n2,"res_cube_movie")
!!$     call to_history ("n3",   n3*2,"res_cube_movie")
!!$     call to_history ("n4", movie_index  ,"res_cube_movie")
!!$     call to_history ("esize",4,"res_cube_movie")

     !
     call sep_close()
     call exit (0)

  case(1)  ! 2D integration----1 slice at a time but proper regularization using conjagate gradients with a model mask


     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",d1)
     call to_history ("d2",d2)
     call to_history ("d3",d3)
     call to_history ("o1",o1)
     call to_history ("o2",o2)
     call to_history ("o2",o3)

     allocate(dtau(n1*n2*1),tau(n1*n2*1),tau2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,2),px_dat(n1,n2,1),px(n1,n2,1))
     allocate(resid(n1*n2*2))
     allocate( rt( n1*n2*2),rt_new(n1*n2*2),grad_tau(n1*n2*2))
     allocate(tau_grad(n1,n2))
     allocate(model_mask_2d(n1,n2),model_mask_1d(n1*n2),initial_model(n1*n2),initial_poly(n1*n2),initial_model_2d(n1,n2))
     dtau=0.
     tau=0.
     tau_grad=0.
     px_new=0.
     initial_model=0.

     model_mask_2d=1.
     !    model_mask_2d(60:80,1:)=0.
     !   model_mask_2d(70,1:)=0.
     !   model_mask_2d(110,1:)=0.
!!$model_mask_2d(63,14)=0
!!$model_mask_2d(63,75)=0
!!$model_mask_2d(63,89)=0
!!$model_mask_2d(63,50)=0

     model_mask_2d(1:,ref_2)=0.

     model_mask_2d(38,1:)=0.
     model_mask_2d(68,1:)=0.

!!$
!!$     model_mask_2d(66,7)=0.
!!$     model_mask_2d(66,37)=0.
!!$     model_mask_2d(66,50)=0.
!!$     model_mask_2d(66,63)=0.
!!$     model_mask_2d(66,70)=0.
!!$     model_mask_2d(66,90)=0.
!!$     model_mask_2d(66,98)=0.

     !    model_mask_2d=1.  ! TO TURN OFF MASK
     model_mask_1d=1.
     !model_mask_1d(n1*n2+1:n1*n2*2)=reshape(model_mask_2d,(/n1*n2/))
     model_mask_1d=reshape(model_mask_2d,(/n1*n2/))
     !  model_mask_1d=1.

     call igrad2_2d_reg_init(n1,n2,eps_t)
     call igrad2_init(n1,n2)
     call igrad1_2d_off_init(n1,n2)
     !     call eps_weight_init(n1,n2,eps_t)


     write(0,*) 'eps',eps_t
     if (exist_file("initial_model")) call sreed("initial_model", initial_model,4*n1*n2)


     initial_model_2d=reshape(initial_model,(/n1,n2/))


     !  initial_model_2d=0 ! TO TURN OFF INITIAL SOLUTION
!!$
!!$     initial_model_2d(66,7)=29. 
!!$     initial_model_2d(66,37)=17.
!!$     initial_model_2d(66,50)=0.  
!!$     initial_model_2d(66,63)=-16
!!$     initial_model_2d(66,70)=-18.
!!$     initial_model_2d(66,90)=-22.
!!$     initial_model_2d(66,98)=-9.


     k=1
     na=10
     epsi=.1
     !   aa = lapfac2(epsi,n1,na) ! REMOVED
     aa = lapfac2d(epsi,n1,na,eps_t) ! REMOVED
     call polydiv_init(n1*n2,aa) ! REMOVED

     !initial_model_2d=0.
     initial_model=reshape(initial_model_2d,(/n1*n2/))

     call helicon_init(aa) ! REMOVED
     call flat_chain_init(n1*n2)

     call model_mask_init(model_mask_1d)



     initial_poly=0.

     do it=1,n3
        write(0,*) '1'
        call sep_read(px,"dipx")
        write(0,*) '2'
        !        px(1:60,1:,1)=0.
        !        px(110:,1:,1)=0.
        px_new=0.
        px_new(1:,1:,2)=px(1:,1:,1)
        rt=0.
        rt(n1*n2+1:n1*n2*2)=reshape(px,(/size(px)/))
        rt_new=rt
        write(0,*) '2.5'
        !px_ew(1:80,1:,2)=0.
        write(0,*) maxval(px),minval(px),sum(px)/size(px)

        hh=0.
        tau=0.
        dtau=0.
        write(0,*) '3'
        do iter=1,niter
           !  allocate( rt( n1*n2))
           !     rt(1:n1*n2*2)=reshape(px_new,(/size(px_new)/))


           !    call dot_test (flat_chain_exec,n1*n2,n1*n2*2,dot1,dot2)

           !   if (iter==1) then
           stat1=igrad2_2d_reg_lop(.false.,.true.,-initial_model,rt_new)  !  r-grad (tau0)
!!$! BEST WITHOUT PRECONDITIONING
!!$  call solver_smp(dtau, rt,igrad2_2d_reg_lop,cgstep,linear_niter,verb=.true.,Jop=model_mask_lop)
           ! BEST 
           call solver_prc(dtau, rt_new,flat_chain_exec,polydiv_lop,cgstep,n1*n2*n3,linear_niter,0.,verb=.true.)
           ! dtau=dtau*model_mask_1d+initial_model  ! Fill in known model points
           ! else 
!!$! BEST WITHOUT PRECONDITIONING
!!$ call solver_smp(dtau, rt,igrad2_2d_reg_lop,cgstep,linear_niter,Jop=model_mask_lop,verb=.true.)
           ! BEST
           !  stat1=igrad2_2d_reg_lop(.false.,.true.,-initial_model,rt)  !  r-grad (tau0)
           !   call solver_prc(dtau, rt,flat_chain_exec,polydiv_lop,cgstep,n1*n2*n3,linear_niter,0.,verb=.true.)
           ! end if

           call cgstep_close ()


           tau=tau+dtau
           tau=tau*model_mask_1d+initial_model 


           write(0,*) maxval(px_new)   

           call p_at_tau2D (tau,rt,rt_new,n1,n2,ref_2)    !  p(tau)
           stat1=flat_chain_exec(.false.,.false.,tau,grad_tau) !  grad_tau
           rt_new=rt_new-grad_tau  
           !        call correct_dip_2D  (tau,px,px_dat,ref_2)
!!$
!!$           ! CALCULATE MODEL RESIDUAL
!!$           tau2D=reshape(tau,(/n1,n2/))
!!$           tau_grad=0.
!!$           do i= 1, n1-1 
!!$              do j= 1, n2-1 
!!$                 tau_grad(i,j)= tau_grad(i,j)+( tau2D(i+1,j) - tau2D(i,j)) 
!!$              end do
!!$           end do
!!$           px_new(1:,1:,1)=-eps_t*tau_grad(1:,1:)
!!$
!!$           px_new(1:,1:,2)=px_dat(1:,1:,1)
!!$
!!$           write(0,*) maxval(px_new)   
!!$
!!$
!!$           resid=reshape(px_new,(/n1*n2*2/))

           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
!!$           call sep_write (tau,"mod_movie")
!!$           call sep_write (px_new,"res_movie")
        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do

     !DELETE !!!
     do it=1,n1
        hh_2D(it,1:)=it
     end do
!!$     call sep_write (hh_2D(1:n1,1:n2),"junk")
!!$     call to_history ("n1",   n1,"junk")
!!$     call to_history ("n2",   n2,"junk")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   niter,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n1,"res_movie")
     call to_history ("n2",   n2*2,"res_movie")
     call to_history ("n3",   niter,"res_movie")    
     call to_history ("esize",4,"res_movie")

  case(2)  ! 2D integration----1 slice at a time but proper regularization using conjagate gradients with a model mask


     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",d1)
     call to_history ("d2",d2)
     call to_history ("d3",d3)
     call to_history ("o1",o1)
     call to_history ("o2",o2)
     call to_history ("o2",o3)

     allocate(dtau(n1*n2*1),tau(n1*n2*1),tau2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,2),px_dat(n1,n2,1),px(n1,n2,1))
     allocate(resid(n1*n2*2))
     allocate( rt( n1*n2*2),rt_new(n1*n2*2),grad_tau(n1*n2*2))
     allocate(tau_grad(n1,n2))
     allocate(model_mask_2d(n1,n2),model_mask_1d(n1*n2),initial_model(n1*n2),initial_poly(n1*n2),initial_model_2d(n1,n2))
     dtau=0.
     tau=0.
     tau_grad=0.
     px_new=0.
     initial_model=0.

     model_mask_2d=1.
     !    model_mask_2d(60:80,1:)=0.
     !   model_mask_2d(70,1:)=0.
     !   model_mask_2d(110,1:)=0.
!!$model_mask_2d(63,14)=0
!!$model_mask_2d(63,75)=0
!!$model_mask_2d(63,89)=0
!!$model_mask_2d(63,50)=0

     model_mask_2d(1:,ref_2)=0.

     model_mask_2d(38,1:)=0.
     model_mask_2d(68,1:)=0.

!!$
!!$     model_mask_2d(66,7)=0.
!!$     model_mask_2d(66,37)=0.
!!$     model_mask_2d(66,50)=0.
!!$     model_mask_2d(66,63)=0.
!!$     model_mask_2d(66,70)=0.
!!$     model_mask_2d(66,90)=0.
!!$     model_mask_2d(66,98)=0.

     !    model_mask_2d=1.  ! TO TURN OFF MASK
     model_mask_1d=1.
     !model_mask_1d(n1*n2+1:n1*n2*2)=reshape(model_mask_2d,(/n1*n2/))
     model_mask_1d=reshape(model_mask_2d,(/n1*n2/))
     !  model_mask_1d=1.

     call igrad2_2d_reg_init(n1,n2,eps_t)
     call igrad2_init(n1,n2)
     call igrad1_2d_off_init(n1,n2)
     !     call eps_weight_init(n1,n2,eps_t)


     write(0,*) 'eps',eps_t
     if (exist_file("initial_model")) call sreed("initial_model", initial_model,4*n1*n2)


     initial_model_2d=reshape(initial_model,(/n1,n2/))


     !  initial_model_2d=0 ! TO TURN OFF INITIAL SOLUTION
!!$
!!$     initial_model_2d(66,7)=29. 
!!$     initial_model_2d(66,37)=17.
!!$     initial_model_2d(66,50)=0.  
!!$     initial_model_2d(66,63)=-16
!!$     initial_model_2d(66,70)=-18.
!!$     initial_model_2d(66,90)=-22.
!!$     initial_model_2d(66,98)=-9.


     k=1
     na=10
     epsi=.1
     !   aa = lapfac2(epsi,n1,na) ! REMOVED
     aa = lapfac2d(epsi,n1,na,eps_t) ! REMOVED
     call polydiv_init(n1*n2,aa) ! REMOVED

     !initial_model_2d=0.
     initial_model=reshape(initial_model_2d,(/n1*n2/))

     call helicon_init(aa) ! REMOVED
     call flat_chain_init(n1*n2)

     call model_mask_init(model_mask_1d)



     initial_poly=0.

     do it=1,n3
        write(0,*) '1'
        call sep_read(px,"dipx")
        write(0,*) '2'
        !        px(1:60,1:,1)=0.
        !        px(110:,1:,1)=0.
        px_new=0.
        px_new(1:,1:,2)=px(1:,1:,1)
        rt=0.
        rt(n1*n2+1:n1*n2*2)=reshape(px,(/size(px)/))
        rt_new=rt
        write(0,*) '2.5'
        !px_ew(1:80,1:,2)=0.
        write(0,*) maxval(px),minval(px),sum(px)/size(px)

        hh=0.
        tau=0.
        dtau=0.
        write(0,*) '3'
        do iter=1,niter
           !  allocate( rt( n1*n2))
           !     rt(1:n1*n2*2)=reshape(px_new,(/size(px_new)/))


           !    call dot_test (flat_chain_exec,n1*n2,n1*n2*2,dot1,dot2)

           !   if (iter==1) then
           !     stat1=igrad2_2d_reg_lop(.false.,.true.,-initial_model,rt_new)  !  r-grad (tau0)
!!$! BEST WITHOUT PRECONDITIONING
!!$  call solver_smp(dtau, rt,igrad2_2d_reg_lop,cgstep,linear_niter,verb=.true.,Jop=model_mask_lop)
           ! BEST 
           !   call solver_prc(dtau, rt_new,flat_chain_exec,polydiv_lop,cgstep,n1*n2*n3,linear_niter,0.,verb=.true.)
           call solver_prc(dtau, rt_new,igrad2_2d_reg_lop,polydiv_lop,cgstep,n1*n2*n3,linear_niter,0.,verb=.true.)
           ! dtau=dtau*model_mask_1d+initial_model  ! Fill in known model points
           ! else 
!!$! BEST WITHOUT PRECONDITIONING
!!$ call solver_smp(dtau, rt,igrad2_2d_reg_lop,cgstep,linear_niter,Jop=model_mask_lop,verb=.true.)
           ! BEST
           !  stat1=igrad2_2d_reg_lop(.false.,.true.,-initial_model,rt)  !  r-grad (tau0)
           !   call solver_prc(dtau, rt,flat_chain_exec,polydiv_lop,cgstep,n1*n2*n3,linear_niter,0.,verb=.true.)
           ! end if

           call cgstep_close ()


           tau=tau+dtau
           !  tau=tau*model_mask_1d+initial_model 


           write(0,*) maxval(px_new)   

           call p_at_tau2D (tau,rt,rt_new,n1,n2,ref_2)    !  p(tau)
           !   stat1=flat_chain_exec(.false.,.false.,tau,grad_tau) !  grad_tau
           stat1=igrad2_2d_reg_lop(.false.,.false.,tau,grad_tau) !  grad_tau

           rt_new=rt_new-grad_tau  
           !        call correct_dip_2D  (tau,px,px_dat,ref_2)
!!$
!!$           ! CALCULATE MODEL RESIDUAL
!!$           tau2D=reshape(tau,(/n1,n2/))
!!$           tau_grad=0.
!!$           do i= 1, n1-1 
!!$              do j= 1, n2-1 
!!$                 tau_grad(i,j)= tau_grad(i,j)+( tau2D(i+1,j) - tau2D(i,j)) 
!!$              end do
!!$           end do
!!$           px_new(1:,1:,1)=-eps_t*tau_grad(1:,1:)
!!$
!!$           px_new(1:,1:,2)=px_dat(1:,1:,1)
!!$
!!$           write(0,*) maxval(px_new)   
!!$
!!$
!!$           resid=reshape(px_new,(/n1*n2*2/))

           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
!!$           call sep_write (tau,"mod_movie")
!!$           call sep_write (px_new,"res_movie")
        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do

     !DELETE !!!
     do it=1,n1
        hh_2D(it,1:)=it
     end do
!!$     call sep_write (hh_2D(1:n1,1:n2),"junk")
!!$     call to_history ("n1",   n1,"junk")
!!$     call to_history ("n2",   n2,"junk")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   niter,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n1,"res_movie")
     call to_history ("n2",   n2*2,"res_movie")
     call to_history ("n3",   niter,"res_movie")    
     call to_history ("esize",4,"res_movie")


  case(3)  ! 2D integration----1 slice at a time but proper regularization using Fourier domain with a model mask

     allocate(ztrans(n1*2,n2*2,1))
     call z_trans(n1*2,n2*2,1,eps_t**2,0.,ztrans)

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",d1)
     call to_history ("d2",d2)
     call to_history ("d3",d3)
     call to_history ("o1",o1)
     call to_history ("o2",o2)
     call to_history ("o2",o3)

     allocate(dtau(n1*n2*1),tau(n1*n2*1),tau2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,2),px_dat(n1,n2,1),px(n1,n2,1))
     allocate(resid(n1*n2*2))
     allocate( rt( n1*n2*2),rt_new(n1*n2*2),r0(n1*n2*2),r1(n1*n2*2),grad_tau(n1*n2*2))
     allocate(tau_grad(n1,n2))
     allocate(model_mask_2d(n1,n2),model_mask_1d(n1*n2),initial_model(n1*n2),initial_poly(n1*n2),initial_model_2d(n1,n2))
     dtau=0.
     tau=0.
     tau_grad=0.
     px_new=0.
     initial_model=0.

     model_mask_2d=1.
     !    model_mask_2d(60:80,1:)=0.
     !   model_mask_2d(70,1:)=0.
     !   model_mask_2d(110,1:)=0.
!!$model_mask_2d(63,14)=0
!!$model_mask_2d(63,75)=0
!!$model_mask_2d(63,89)=0
!!$model_mask_2d(63,50)=0

     model_mask_2d(1:,ref_2)=0.

     model_mask_2d(38,1:)=0.
     model_mask_2d(68,1:)=0.

!!$
!!$     model_mask_2d(66,7)=0.
!!$     model_mask_2d(66,37)=0.
!!$     model_mask_2d(66,50)=0.
!!$     model_mask_2d(66,63)=0.
!!$     model_mask_2d(66,70)=0.
!!$     model_mask_2d(66,90)=0.
!!$     model_mask_2d(66,98)=0.

     !    model_mask_2d=1.  ! TO TURN OFF MASK
     model_mask_1d=1.
     !model_mask_1d(n1*n2+1:n1*n2*2)=reshape(model_mask_2d,(/n1*n2/))
     model_mask_1d=reshape(model_mask_2d,(/n1*n2/))
     !  model_mask_1d=1.

     call igrad2_2d_reg_init(n1,n2,eps_t)
     call igrad2_init(n1,n2)
     call igrad1_2d_off_init(n1,n2)
     !     call eps_weight_init(n1,n2,eps_t)


     write(0,*) 'eps',eps_t
     if (exist_file("initial_model")) call sreed("initial_model", initial_model,4*n1*n2)


     initial_model_2d=reshape(initial_model,(/n1,n2/))


     !  initial_model_2d=0 ! TO TURN OFF INITIAL SOLUTION
!!$
!!$     initial_model_2d(66,7)=29. 
!!$     initial_model_2d(66,37)=17.
!!$     initial_model_2d(66,50)=0.  
!!$     initial_model_2d(66,63)=-16
!!$     initial_model_2d(66,70)=-18.
!!$     initial_model_2d(66,90)=-22.
!!$     initial_model_2d(66,98)=-9.


     k=1
     na=10
     epsi=.1
     !   aa = lapfac2(epsi,n1,na) ! REMOVED
     aa = lapfac2d(epsi,n1,na,eps_t) ! REMOVED
     call polydiv_init(n1*n2,aa) ! REMOVED

     !initial_model_2d=0.
     initial_model=reshape(initial_model_2d,(/n1*n2/))

     call helicon_init(aa) ! REMOVED
     call flat_chain_init(n1*n2)

     call model_mask_init(model_mask_1d)



     initial_poly=0.

     do it=1,n3
        write(0,*) '1'
        call sep_read(px,"dipx")
        write(0,*) '2'
        !        px(1:60,1:,1)=0.
        !        px(110:,1:,1)=0.
        px_new=0.
        px_new(1:,1:,2)=px(1:,1:,1)
        rt=0.
        rt(n1*n2+1:n1*n2*2)=reshape(px,(/size(px)/))
        rt_new=rt
        write(0,*) '2.5'
        !px_ew(1:80,1:,2)=0.
        write(0,*) maxval(px),minval(px),sum(px)/size(px)

        hh=0.
        tau=0.
        dtau=0.
        write(0,*) '3'
        stat1=igrad2_2d_reg_lop(.false.,.false.,initial_model,r0) 

        do iter=1,niter
           !  allocate( rt( n1*n2))
           !     rt(1:n1*n2*2)=reshape(px_new,(/size(px_new)/))


           !    call dot_test (flat_chain_exec,n1*n2,n1*n2*2,dot1,dot2)

           !   if (iter==1) then

           call p_at_tau2D (tau,rt,r1,n1,n2,ref_2)    !  p(tau)
write(0,*) 'max,min,rt',maxval(rt),minval(rt),maxval(r1),minval(r1)

           do liter=1,linear_niter


              stat1=flat_chain_exec(.false.,.false.,tau,grad_tau) !  grad_tau
             !    stat1=igrad2_2d_reg_lop(.false.,.false.,taugrad_tau) !  grad_tau
  write(0,*) 'max,min,grad_tau',maxval(grad_tau),minval(grad_tau)
            rt_new=r1-grad_tau-r0

  !rt_new=r0

!if (liter>1) rt_new=r0
!!$if (liter==1) then
!!$              call sep_write (rt_new,"junk")
!!$              call to_history ("n1",   n1,"junk")
!!$              call to_history ("n2",   n2,"junk")
!!$              call to_history ("n3",   2,"junk")
!!$!rt_new(1:n1*n2)=1.
!!$end if
!rt_new(1:n1*n2)=1.
       !  rt_new=rt_new-r0

              !   stat1=igrad2_2d_reg_lop(.false.,.true.,-initial_model,rt_new)  !  r-grad (tau0)
!!$! BEST WITHOUT PRECONDITIONING
!!$  call solver_smp(dtau, rt,igrad2_2d_reg_lop,cgstep,linear_niter,verb=.true.,Jop=model_mask_lop)
              ! BEST 
              !   call solver_prc(dtau, rt_new,flat_chain_exec,polydiv_lop,cgstep,n1*n2*n3,linear_niter,0.,verb=.true.)
              ! dtau=dtau*model_mask_1d+initial_model  ! Fill in known model points
              ! else 
!!$! BEST WITHOUT PRECONDITIONING
!!$ call solver_smp(dtau, rt,igrad2_2d_reg_lop,cgstep,linear_niter,Jop=model_mask_lop,verb=.true.)
              ! BEST
              !  stat1=igrad2_2d_reg_lop(.false.,.true.,-initial_model,rt)  !  r-grad (tau0)
              !   call solver_prc(dtau, rt,flat_chain_exec,polydiv_lop,cgstep,n1*n2*n3,linear_niter,0.,verb=.true.)
              ! end if

              call dipintegrate_2D_pck (rt_new,dtau,eps_t,n1,n2,ztrans) 

              !   call cgstep_close ()


              tau=tau+dtau


              write(0,*) maxval(px_new)   

              !       call p_at_tau2D (tau,rt,rt_new,n1,n2,ref_2)    !  p(tau)
              !             stat1=flat_chain_exec(.false.,.false.,tau,grad_tau) !  grad_tau
              !             rt_new=rt_new-grad_tau  
              !        call correct_dip_2D  (tau,px,px_dat,ref_2)
!!$
!!$           ! CALCULATE MODEL RESIDUAL
!!$           tau2D=reshape(tau,(/n1,n2/))
!!$           tau_grad=0.
!!$           do i= 1, n1-1 
!!$              do j= 1, n2-1 
!!$                 tau_grad(i,j)= tau_grad(i,j)+( tau2D(i+1,j) - tau2D(i,j)) 
!!$              end do
!!$           end do
!!$           px_new(1:,1:,1)=-eps_t*tau_grad(1:,1:)
!!$
!!$           px_new(1:,1:,2)=px_dat(1:,1:,1)
!!$
!!$           write(0,*) maxval(px_new)   
!!$
!!$
!!$           resid=reshape(px_new,(/n1*n2*2/))

              write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
!!$           call sep_write (tau,"mod_movie")
!!$           call sep_write (px_new,"res_movie")

           end do
        end do
  !      tau=tau*model_mask_1d+initial_model 

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do

     !DELETE !!!
     do it=1,n1
        hh_2D(it,1:)=it
     end do
!!$     call sep_write (hh_2D(1:n1,1:n2),"junk")
!!$     call to_history ("n1",   n1,"junk")
!!$     call to_history ("n2",   n2,"junk")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   niter,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n1,"res_movie")
     call to_history ("n2",   n2*2,"res_movie")
     call to_history ("n3",   niter,"res_movie")    
     call to_history ("esize",4,"res_movie")
  end select


end program Dipintegrator_geo_prec



!!$
!!$integer function flat_chain_exec( adj, add, model, data)
!!$  logical       :: adj, add
!!$  real          :: data(:), model(:)
!!$  call chain20( igrad2_2d_reg_lop,model_mask_lop,adj, add, model, data,temp1)
!!$  !   call chain2( igrad2_2d_reg_lop,model_mask_lop,adj, add, model, data,temp1)
!!$  flat_chain_exec=0
!!$end function flat_chain_exec







