program Flatten_out_sinc  !
  ! Flatten in outspace using sinc interpolation 6/28/05 jml
  !
  use sep
  use lint1
  use bessel_jml
  use bessel_prg
  use sinc_mod
  use iflport

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,knownvec1,knownvec2,data_out_index,subsam, shift_floor, shift_ceil, useinwt,ref_2,ref_3,flatten,horizons,horizon_inc
  integer                                ::horizon_strt,slice,sinc_win,isinc,sinc_index,sinc_sample
  integer                                ::I,tab_size
  integer, dimension(:,:,:), allocatable    :: knownvec
  real,    dimension (:,:,:),   allocatable :: data_in,data_out,time_cube,outwt,inwt,data_out2
  real,    dimension (:),       allocatable :: table_vec
  real, save, pointer, dimension(:)         ::lint_in, lint_out,padded_data_in 
  double precision, pointer, dimension(:)           ::test       
  real, save, pointer                        ::coord
  real                                      ::shift,iprl, diffrl,shift_diff,upwt,dwnwt,xrand,sinc_val,pi,sinc_distance,pad_shift,alpha
  ! real, external ::j0_

  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call to_history ("esize",4)
  call from_param("useinwt",useinwt,0);
  call from_param("ref_2",ref_2,n2/2)  !locate of the reference trace on the 2-axis
  call from_param("ref_3",ref_3,n3/2) !locate of the reference trace on the 3-axis
  call from_param("flatten",flatten,1)
  call from_param("horizons",horizons,0)
  call from_param("horizon_inc",horizon_inc,30)
  call from_param("horizon_strt",horizon_strt,1)
  call from_param("slice",slice,0)
  call from_param("sinc_win",sinc_win,21)
  call from_param("alpha",alpha,300.)
  call from_param("tab_size",tab_size,2000)
  write(0,*) n1,n2,n3,ref_2,ref_3,horizon_inc
  write(0,*)'slice',slice

  subsam=1
  allocate (data_in (n1,n2,n3),time_cube(n1,n2,n3),data_out(n1,n2,n3),knownvec(n1,n2,n3),outwt(n1,n2,n3),inwt(n1,n2,n3)) 
  allocate(padded_data_in(n1+2*sinc_win))
  ! read data
  ! ; data = data / maxval (cabs (data)) ! normalize


  pi=acos(-1.)
  if (useinwt==0.) then
     inwt=1.
  else 
     call sreed("inwt", inwt,4*n1*n2*n3)
     write(0,*) 'min of outwt', minval(outwt),maxval(outwt), sum(outwt)/size(outwt)
  endif


  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", data_in,4*n1*n2*n3)
  call sreed("aux", time_cube,4*n1*n2*n3)
  outwt=1.  !inwt
  data_in=data_in*inwt


!  write(0,*) 'horizon_inc',horizon_inc,'horizon_strt',horizon_strt
  if (horizons.and.flatten==0.) then
     data_in=0.
     do i1=horizon_strt,n1-1,horizon_inc
        ! data_in(i1-1:i1+1,1:n2:1,1:n3:1)=-1.
        data_in(i1,1:n2:1,1:n3:1)=1.
        !  data_in(i1,2:n2:2,1:n3:1)=-1.
        !  data_in(i1-1:i1+1,2:n2:1,2:n3:2)=-1.
        ! data_in(i1,2:n2:1,2:n3:2)=1.
!!$  data_in(i1,1:n2:1,1:n3:1)=1.

     end do
  end if





  data_out=0.
  write(0,*) 'n1/n2/n3',n1,n2,n3
  !  write(0,*) 'max ref',maxval(time_cube(1:,ref_2,ref_3)),minval(time_cube(1:,ref_2,ref_3))
  !data_out(1,:,:)=data_in(1,:,:)
  allocate(table_vec(tab_size))
  call sinc_tab(table_vec,alpha,sinc_win)
  write(0,*) 'CREATED SINC TABLE' 
  do i3=1,n3
     do i2=1,n2
        do i1=1,n1


           shift=(time_cube(i1,i2,i3))-time_cube(i1,ref_2,ref_3) !  -5.4
           if (slice==2) shift=(time_cube(i1,i2,i3))-time_cube(i1,ref_2,i3) 


           if (time_cube(i1,i2,i3)==0.) then
              shift=0.
           end if

           shift_floor=floor(shift) 
           shift_ceil=shift_floor+1
           shift_diff=shift-shift_floor

           upwt = shift_diff 
           dwnwt= 1-shift_diff



           if (flatten) then  ! TO FLATTEN

              padded_data_in(1:sinc_win)=data_in(sinc_win+1:1:-1,i2,i3)  !pad out the input data for sinc interpolation
              padded_data_in(sinc_win+1:n1+sinc_win)=data_in(1:n1,i2,i3)
              padded_data_in(n1+sinc_win+1:)=data_in(n1-1:n1-sinc_win:-1,i2,i3) 


!!$              if (i1+shift_ceil>n1.OR.i1+shift_floor<1) then
!!$                 !             data_out(data_out_index,i2,i3)=0.
!!$                 outwt(i1,i2,i3)=0.0
!!$              else

              ! knownvec(i1,i2,i3)=i1-shift_floor

!!$                 data_out(i1,i2,i3)= dwnwt*data_in(i1+shift_floor,i2,i3)+upwt*data_in(i1+shift_ceil,i2,i3) ;

              sinc_val=0.

!!$                 if (shift==shift_floor) then 
!!$                    data_out(i1,i2,i3)=data_in(i1+shift_floor,i2,i3)
!!$                 elseif  (shift==shift_ceil) then
!!$                    data_out(i1,i2,i3)=data_in(i1+shift_ceil,i2,i3)
!!$                 else
!!$
!!$                    do isinc=1,sinc_win+1  !! calculate based on the 20 points to the left
!!$                       sinc_val=sinc_val+padded_data_in(i1+isinc-1+shift_floor) * (sin(pi*(real(sinc_win-isinc+1)+shift_diff))/\
!!$                       (pi*(real(sinc_win-isinc+1)+shift_diff)))
!!$                    end do
!!$                    do isinc=sinc_win+1,2*sinc_win+1 !! calculate based on the 20 points to the right
!!$                       sinc_val=sinc_val+padded_data_in(i1+isinc+shift_floor) * (sin(pi*(real(-sinc_win+isinc-1)+(1.-shift_diff)))/\
!!$                       (pi*(real(-sinc_win+isinc-1)+(1.-shift_diff))))
!!$                    end do
!!$
!!$                    if (real(sinc_win)/2.-floor(real(sinc_win)/2.) <.000001) then
!!$                       write(0,*) 'SINC WINDOW MUST BE ODD'
!!$                       call exit(0)
!!$                    end if
!!$
              !write(0,*) 'sinc_win',sinc_win
  !write(0,*) i1,i2,i3
              do isinc=1,sinc_win
                 !         sinc_index=floor(real(sinc_win)/2.)+(isinc-1)
                 !  sinc_index=shift_floor-(floor(real(sinc_win)/2.)-1)+(isinc-1)+sinc_win+i1 ! IDENTIFY EACH CONTRIBUTING NODE
                 sinc_index=max(1,shift_floor+i1-(floor(real(sinc_win)/2.)-1)+(isinc-1)+sinc_win)
                 sinc_index=min(size(padded_data_in),sinc_index)
! write(0,*) sinc_index,size(padded_data_in),isinc,sinc_win
!! this was failing because sinc_index=0 so i added the above line as a quick work around       
!! sinc_index=shift_floor+i1-(floor(real(sinc_win)/2.)-1)+(isinc-1)+sinc_win

!if (i1>=1.and.i2>=25.and.i3>=75) write(0,*) 'sinc index',sinc_index
 
                 pad_shift=shift+real(i1)+real(sinc_win)
                 sinc_distance=abs(real(sinc_index)-pad_shift)
                 sinc_sample=nint((sinc_distance/(real(sinc_win)/2.+1.))* real(tab_size))    ! TABLE: SELECT SINC VALUE USING NEAREST NEIGHBOR
! if (i1>=1.and.i2>=25.and.i3>=75) write(0,*) 'pad_shift',pad_shift,'sinc_distance',sinc_distance,'sinc_sample',sinc_sample,'alpha',alpha,'sinc_win',sinc_win,'size padded_data_in',size(padded_data_in)


!write(0,*) 'sinc_sample',sinc_sample,sinc_distance,(real(sinc_win)/2.)+1
             !    if (sinc_sample>2000) write(0,*) 'error' ;stop
!!$write(0,*) 'sinc index',sinc_index
! if (i1>=1.and.i2>=25.and.i3>=75) write(0,*) 'about to go into sinc func' 
                 sinc_val=sinc_val+padded_data_in(sinc_index) *sinc_func(sinc_distance,alpha, sinc_win) ! 
!if (i1>=1.and.i2>=25.and.i3>=75) write(0,*) 'mad it out of sinc func' 
!WITHOUT TABLE
               !  sinc_val=sinc_val+padded_data_in(sinc_index)*table_vec(sinc_sample) ! WITH TABLE

            !!           write(0,*) 'sinc_sample',sinc_sample,'sinc_distance',sinc_distance,'table_vec',table_vec(sinc_sample)
              end do



              data_out(i1,i2,i3)=sinc_val

!!$              end if

              !/* Windowed sinc */
              !double W_sinc(const float xmn,const int N) {
              !  double xmnoN,pixmn;
              !  if (xmn==0.0) return 1.0;
              !  xmnoN=xmn/N;
              !  pixmn=PI*xmn;
              !  return sin(pixmn)*j0(alpha*sqrt(1-xmnoN*xmnoN))/(j0(alpha)*pixmn);
              !} !!!!  cd ~rckt/cplusplus/src/lib




              !if (i2==1.and.i3==1) write(0,*) shift


           else  ! TO UNFLATTEN

              if (i1+shift_floor>1 .and. i1+shift_ceil<n1) then 
                 !      data_out(i1+shift_floor,i2,i3)=data_out(i1+shift_floor,i2,i3)+ dwnwt*data_in(i1,i2,i3)
                 !      data_out( i1+shift_ceil ,i2,i3)=data_out(i1+shift_ceil   ,i2,i3)+ upwt*data_in(i1,i2,i3)
                 ! NEAREST NEIGHBOR
                 data_out(i1+nint(shift),i2,i3)=data_out(i1+nint(shift),i2,i3)+data_in(i1,i2,i3)


              end if

           end if

        end do
     end do
  end do

  if (horizons.and.flatten==0.) then
     allocate(data_out2(n1,n2,n3))
     data_out2=data_out
     do i3=1,n3
        do i2=1,n2
           do i1=2,n1-1 
              if (data_out(i1,i2,i3)>.1.and.data_out(i1-1,i2,i3)<.1.and.data_out(i1+1,i2,i3)<.1.and.data_out2(i1-1,i2,i3)<.1.and.data_out2(i1+1,i2,i3)<.1) then
                 !        data_out2(i1,i2,i3)=-1. !data_out(i1,i2,i3)
                 !       data_out2(i1-1,i2,i3)=1.
                 !   data_out2(i1+1,i2,i3)=1.
              end if
           end do
        end do
     end do
     !   data_out=data_out2
  end if

  !  write(0,*) knownvec(10:30,6,6)
  !! linear interpolation
!!$  do i3=1,n3
!!$     do i2=1,n2
!!$        do i1=1,n1-1
!!$           knownvec1=knownvec(i1,i2,i3)
!!$           knownvec2=knownvec(i1+1,i2,i3)
!!$
!!$           diff=knownvec2-knownvec1
!!$           !           write(0,*) 'diff',diff
!!$           if (diff >=3) then
!!$
!!$              do ip=1,diff-2
!!$                 iprl=ip
!!$                 diffrl=diff-1.
!!$
!!$                 !  data_out(knownvec1+ip,i2,i3)=data_out(knownvec1,i2,i3)*(1.-iprl/diffrl) + data_out(knownvec2-1,i2,i3)*(iprl/diffrl)
!!$
!!$              end do
!!$           end if
!!$        end do
!!$     end do
!!$  end do

  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  !call to_history("d1",1)
  call sep_write (data_out) 

  outwt=outwt*inwt

!!$  call to_history("n1",n1,"outwt"); call to_history("n2",n2,"outwt")
!!$  call to_history("n3",n2,"outwt")
!!$  call to_history("d1",1.0,"outwt"); call to_history("d2",1.0,"outwt")
!!$  call to_history("d3",1.0,"outwt")
!!$  call to_history("o1",0.,"outwt"); call to_history("o2",0.,"outwt")
!!$  call to_history("o3",0.,"outwt")
!!$  call to_history("esize",4,"outwt")
!!$  call sep_write(outwt,"outwt")	





  deallocate (data_out)
  call sep_close()
  call exit (0)
end program Flatten_out_sinc














