program Flatten_strat  !
  !  unflatted a cube with a time shift cube
  !
  use sep
  use lint1

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,knownvec1,knownvec2,data_out_index,subsam, shift_floor, shift_ceil, useinwt,ref_2,ref_3,flatten,horizons,horizon_inc
  integer                                ::horizon_strt,slice
  integer                                ::n1_aux
  real                                   ::o1_aux
  integer, dimension(:,:,:), allocatable    :: knownvec
  real,    dimension (:,:,:),   allocatable :: data_in,data_out,time_cube,outwt,inwt,data_out2  
  real,    dimension (:,:),   allocatable :: ref_array
  real, save, pointer, dimension(:)         ::lint_in, lint_out
  real, save, pointer                        ::coord
  real                                      ::shift,iprl, diffrl,shift_diff,upwt,dwnwt,xrand
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call to_history ("esize",4)
  call from_param("useinwt",useinwt,0);
  call from_param("ref_2",ref_2,n2/2)  !locate of the reference trace on the 2-axis
  call from_param("ref_3",ref_3,n3/2) !locate of the reference trace on the 3-axis
  call from_param("flatten",flatten,1)
  call from_param("horizons",horizons,0)
  call from_param("horizon_inc",horizon_inc,30)
  call from_param("horizon_strt",horizon_strt,1)
  call from_param("slice",slice,0)

  call from_aux("aux",n1_aux)  
  call from_aux("aux","o1",o1_aux)  

  write(0,*) n1,n2,n3,ref_2,ref_3,horizon_inc
  write(0,*)'slice',slice

  subsam=1
  allocate (data_in (n1,n2,n3),time_cube(n1_aux,n2,n3),data_out(n1_aux,n2,n3),ref_array(n1_aux,2))                                  ! read data
  ! ; data = data / maxval (cabs (data)) ! normalize


  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", data_in,4*n1*n2*n3)
  call sreed("aux", time_cube,4*n1_aux*n2*n3)
  call sreed("ref", ref_array,4*n1_aux*2)

  write(0,*) 'horizon_inc',horizon_inc,'horizon_strt',horizon_strt
  if (horizons.and.flatten==0.) then
     data_in=0.
     do i1=horizon_strt,n1-1,horizon_inc
        ! data_in(i1-1:i1+1,1:n2:1,1:n3:1)=-1.
        data_in(i1,1:n2:1,1:n3:1)=1.
        !  data_in(i1,2:n2:2,1:n3:1)=-1.
        !  data_in(i1-1:i1+1,2:n2:1,2:n3:2)=-1.
        ! data_in(i1,2:n2:1,2:n3:2)=1.
!!$  data_in(i1,1:n2:1,1:n3:1)=1.

     end do
  end if





  data_out=0.
  write(0,*) 'n1/n2/n3',n1,n2,n3
  do i3=1,n3
     do i2=1,n2
        do i1=1,n1_aux
           ref_2=ref_array(i1,1)
           shift=(time_cube(i1,i2,i3))-time_cube(i1,ref_2,ref_3) !  -5.4
           if (slice==2) shift=(time_cube(i1,i2,i3))-time_cube(i1,ref_2,i3) 


           ! if (time_cube(i1,i2,i3)==0.) then

           if (abs(shift)<0.000001) then
              shift=0.
           end if

           shift_floor=floor(shift) 
           shift_ceil=shift_floor+1
           shift_diff=shift-shift_floor

           upwt = shift_diff 
           dwnwt= 1-shift_diff


           if (flatten) then  ! TO FLATTEN
              !    if (i1+shift_ceil>n1.OR.i1+shift_floor<1.OR.inwt(i1+shift_ceil,i2,i3)==0..OR.inwt(i1+shift_floor,i2,i3)==0.) then
              if (nint(ref_array(i1,2))+shift_ceil>n1.OR.nint(ref_array(i1,2))+shift_floor<1) then
                 !             data_out(data_out_index,i2,i3)=0.

              else

            !  write(0,*) nint(ref_array(i1,2))+shift_floor
                 data_out(i1,i2,i3)= dwnwt*data_in(nint(ref_array(i1,2))+shift_floor,i2,i3)+upwt*data_in(nint(ref_array(i1,2))+shift_ceil,i2,i3)   


              end if
           else  ! TO UNFLATTEN

              if (nint(ref_array(i1,2))+shift_floor>1 .and. nint(ref_array(i1,2))+shift_ceil<n1) then 
       
                 ! NEAREST NEIGHBOR
                 data_out(nint(ref_array(i1,2))+nint(shift),i2,i3)=data_out(nint(ref_array(i1,2))+nint(shift),i2,i3)+data_in(nint(ref_array(i1,2)),i2,i3)


              end if

           end if

        end do
     end do
  end do
!!$ 
  if (horizons.and.flatten==0.) then
     allocate(data_out2(n1_aux,n2,n3))
     data_out2=data_out
     do i3=1,n3
        do i2=1,n2
           do i1=2,n1_aux-1 
              if (data_out(i1,i2,i3)>.1.and.data_out(i1-1,i2,i3)<.1.and.data_out(i1+1,i2,i3)<.1.and.data_out2(i1-1,i2,i3)<.1.and.data_out2(i1+1,i2,i3)<.1) then
                 !        data_out2(i1,i2,i3)=-1. !data_out(i1,i2,i3)
                 !       data_out2(i1-1,i2,i3)=1.
                 data_out2(i1+1,i2,i3)=1.
              end if
           end do
        end do
     end do
 data_out=data_out2
  end if


  call to_history ("n1",   n1_aux)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  !call to_history("d1",1)
  call sep_write (data_out) 




  deallocate (data_out)
  call sep_close()
  call exit (0)
end program Flatten_strat














