program Flatten_w_cube_datapreserve_sinc  !
  !  unflatted a cube with a time shift cube
  !
  use sep
  use lint1
  use lint1_jesse
  use sorting_mod

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,it,data_out_index,subsam, shift_floor, shift_ceil, useinwt,n1_long,min_shift,counter,im
  integer ::mm_min, mm_max, mm_sz,n1_aux,n1_out,ref_2,ref_3,mm_min_1, mm_max_1
  real :: d1,d2,d3,o1,o2,o3
  real,   dimension(:,:), target    :: shifted_outputs,shifted_outputs_pad
  real,    dimension (:,:,:),   allocatable :: data_in,data_out,time_cube,outwt,inwt
  real, save, pointer, dimension(:)         ::lint_in, lint_out,shift_vec,shifted_test,mm_interp
  real, save, dimension(:),pointer                        ::coord
  real                                      ::shift,iprl, diffrl,shift_diff,upwt,dwnwt,max_move,min_move,range_move,pi,mod,first_step,last_step
!!$  !test 
!!$  real,    dimension (:),   allocatable :: sin_test,sin_test_out
!!$  real,    dimension (:,:),   allocatable :: subsample_sin_test

  logical :: flatten
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call from_aux("aux",n1_aux)  
  call to_history ("esize",4)
  call from_param("useinwt",useinwt,0)
  call from_param("subsample",subsam,1)
  call from_param("flatten",flatten,.true.)
  call from_param("ref_2",ref_2,n2/2)  !locate of the reference trace on the 2-axis
  call from_param("ref_3",ref_3,n3/2) !locate of the reference trace on the 3-axis
  write(0,*) 'ref_2/ref_3 coordinates of reference trace',ref_2,ref_3

  call from_history ("d1",d1,1.) ; call from_history ("o1",o1,0.)
  call from_history ("d2",d2,1.) ; call from_history ("o2",o2,0.)
  call from_history ("d3",d3,1.) ; call from_history ("o3",o3,0.)

  pi=acos(-1.)


  allocate (data_in (n1,n2,n3),time_cube(n1_aux,n2,n3),inwt(n1,n2,n3),shift_vec(n1_aux*n2*n3),shifted_outputs(2,n1_aux),shifted_outputs_pad(2,2*n1_aux) )!shifted_outputs(2,n1_aux))                                  ! read data
  ! ; data = data / maxval (cabs (data)) ! normalize


  inwt=0.
  if (useinwt==0.) then
     inwt=1.
  else 
     call sreed("inwt", inwt,4*n1*n2*n3)
     !    write(0,*) 'min of outwt', minval(outwt),maxval(outwt), sum(outwt)/size(outwt)
  endif



  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", data_in,4*n1*n2*n3)
  call sreed("aux", time_cube,4*n1_aux*n2*n3)

  data_in=data_in*inwt
  write(0,*) 'min/max/(time_slc)',minval(time_cube),maxval(time_cube)
  !data_in=0.
  !data_in(100,:,:)=1.
  !time_cube=0.

  write(0,*) 'n1/n2/n3',n1,n2,n3
  !data_out(1,:,:)=data_in(1,:,:)

  !compute range in order to preserve data
  it=1  
  do i3=1,n3
     do i2=1,n2
        do i1=1,n1_aux      
           if(inwt(i1,i2,i3)/=0)then
              shift_vec(it)=(i1-(time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3)))*subsam !  -5.4
              !              write(0,*) 'shift_vec',shift_vec(it) 
              it=it+1
           end if
        end do
     end do
  end do
  max_move=maxval(shift_vec(1:it-1))
  min_move=minval(shift_vec(1:it-1))
  min_shift=floor(min_move)
  range_move=abs(max_move-min_move)
  n1_long=ceiling(range_move)
  write(0,*) 'n1_long',n1_long


  if (flatten) then
     allocate(data_out(n1_long,n2,n3),outwt(n1_long,n2,n3))
     call to_history ("n1",   n1_long)
     call to_history ("d1",d1/subsam) 

  else
     allocate(data_out(n1_aux,n2,n3),outwt(n1,n2,n3))
     call to_history ("n1",   n1_aux)
     call to_history ("d1",d1*subsam) 
  end if
  data_out=0.
  outwt=0.

  write(0,*) 'min_move',min_move
  write(0,*) 'max_move',max_move
  write(0,*) 'range_move',range_move
  write(0,*) 'size of data_out',size(data_out(1:,1,1)),size(data_out(1,1:,1)),size(data_out(1,1,1:))



  do i3=1,n3
     do i2=1,n2
        counter=0

        if  (flatten) then

           do i1=1,n1_aux
!!!! store the shifts
              shift=(i1-(time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3)))*subsam

              shifted_outputs(1,i1)=shift              ! store the shifts
              shifted_outputs(2,i1)=data_in(i1,i2,i3)  ! store the input data value

           end do

!!!! sort the shifts
           call quick_sort(shifted_outputs,1,2,n1)  !sort by shift


!!! interpolate
!!$
!!$           !create test case 
!!$           it=0
!!$           allocate(sin_test(1000),subsample_sin_test(2,20),sin_test_out(1000))
!!$           do im=1,1000
!!$              sin_test(im)=sin((pi/50)*im)
!!$              if (real(im+25)/50.-int(real(im+25)/50.)==0.) then
!!$                 it=it+1
!!$                 subsample_sin_test(1,it)=real(im)
!!$                 subsample_sin_test(2,it)=sin((pi/50)*real(im))
!!$                 write(0,*)  subsample_sin_test(1,it),subsample_sin_test(2,it),im
!!$
!!$              end if
!!$           end do
!!$           call to_history("n1",1000,"sin_test.H") 
!!$           call to_history("esize",4,"sin_test.H")
!!$           call sep_write(sin_test,"sin_test.H")	
!!$           call to_history("n1",20,"sub_sample_sin_test_val.H") 
!!$           call to_history("n2",1,"sub_sample_sin_test_val.H") 
!!$           call to_history("esize",4,"sub_sample_sin_test_val.H")
!!$           call sep_write(subsample_sin_test(2,1:),"sub_sample_sin_test_val.H")	
!!$           subsam=25
!!$           sin_test_out=0.
!!$           mm_min=0.
!!$           do im=1,1000
!!$              do it=1,20
!!$
!!$                 mod=mm_min+(real(im)-1.)
!!$if (mod/=subsample_sin_test(1,it)) then
!!$          !       write(0,*) 'mod',mod,'index ',subsample_sin_test(1,it),subsample_sin_test(2,it)
!!$                 sin_test_out(im)=sin_test_out(im)+subsample_sin_test(2,it)*\
!!$                 sin(pi*(mod-subsample_sin_test(1,it))/subsam)/(pi*(mod-subsample_sin_test(1,it))/subsam)
!!$  !         write(0,*) sin_test_out(im),'=',subsample_sin_test(2,it),'*',sin(pi*(mod-subsample_sin_test(1,it))/subsam),'/',(pi*(mod-subsample_sin_test(1,it))/subsam)
!!$  !         write(0,*) 'mod',mod,'subsample_',subsample_sin_test(1,it)
!!$   !        write(0,*) 'out                                    ',sin(pi*(mod-subsample_sin_test(1,it))/subsam)
!!$else 
!!$sin_test_out(im)=subsample_sin_test(2,it)
!!$                !mm_interp=1.
!!$end if
!!$              end do
!!$           !   stop
!!$           end do
!!$           call to_history("n1",1000,"out.H") 
!!$           call to_history("n2",1,"out.H") 
!!$           call to_history("esize",4,"out.H")
!!$           call sep_write(sin_test_out,"out.H")	
!!$           stop

           shifted_outputs_pad=0.
           shifted_outputs_pad(2,1:n1_aux/2)=shifted_outputs(2,1)
           shifted_outputs_pad(2,n1_aux/2+n1_aux+1:2*n1_aux)=shifted_outputs(2,n1_aux)
          
           first_step=shifted_outputs(1,2)-shifted_outputs(1,1)
           last_step=shifted_outputs(1,n1_aux)-shifted_outputs(1,n1_aux-1)
           !write(0,*) 'first',first_step
           !write(0,*) 'last',last_step
           !stop
        shifted_outputs_pad(2,n1_aux/2+1:n1_aux+n1_aux/2)=shifted_outputs(2,1:)
           shifted_outputs_pad(1,n1_aux/2+1:n1_aux+n1_aux/2)=shifted_outputs(1,1:)
!do ip=1,2*n1_aux
!write(0,*) 'index',shifted_outputs_pad(1,ip),'val',shifted_outputs_pad(2,ip)
!end do
!write(0,*) 'next'
           do ip=n1_aux/2,1,-1
              shifted_outputs_pad(1,ip)=shifted_outputs_pad(1,ip+1)-first_step
              !write(0,*) 'shifst',  shifted_outputs_pad(1,ip)
           end do
! write(0,*) 'shifdsfsdd', shifted_outputs_pad(1,n1_aux+n1_aux/2)
           do ip=n1_aux+n1_aux/2+1,2*n1_aux
              shifted_outputs_pad(1,ip)=shifted_outputs_pad(1,ip-1)+last_step
 !   write(0,*) 'shifst',  shifted_outputs_pad(1,ip)
          end do

!do ip=1,n1_aux
!write(0,*) 'index',shifted_outputs(1,ip),'val',shifted_outputs(2,ip)
!end do
!write(0,*) 'next'
!do ip=1,2*n1_aux
!write(0,*) 'index',shifted_outputs_pad(1,ip),'val',shifted_outputs_pad(2,ip)
!end do
!stop

           mm_min_1=ceiling(shifted_outputs(1,1)) 
           mm_max_1=floor(shifted_outputs(1,n1_aux))

           mm_min=ceiling(shifted_outputs_pad(1,1)) 
           mm_max=floor(shifted_outputs_pad(1,2*n1_aux))
   !        write(0,*) 'mm_max',mm_max,'mm_min',mm_min
           mm_sz=mm_max-mm_min+1 
           !write(0,*) 'shifts',shifted_outputs(1,1:10)
           allocate(mm_interp(mm_sz))
           mm_interp=0.
           coord=>shifted_outputs_pad(1,1:)   ! point the coord pointer at the sorted shifts

           do im=1,mm_sz
             mod=mm_min+(real(im)-1.)
             do it=1,2*n1_aux
       
                 if (mod/=shifted_outputs_pad(1,it)) then
                    mm_interp(im)=mm_interp(im)+shifted_outputs_pad(2,it)*\
                    sin(pi*(mod-shifted_outputs_pad(1,it))/subsam)/(pi*(mod-shifted_outputs_pad(1,it))/subsam)
                 else
                   mm_interp(im)=shifted_outputs_pad(2,it)
                 end if
                 !mm_interp=1.
              end do
           end do
           !           call lint1_jesse_init(coord)
           !write(0,*) 'before interp'
           !           stat1=lint1_jesse_lop(.true.,.true.,mm_interp ,shifted_outputs(2,1:))
           !write(0,*) 'after interp'

           !to do sinc interpolation you only have to convolve the sampled input data with the approppriate sinc function.  same thing as band passing.  as  a test, we will just low pass the input signal.


           data_out(mm_min_1-min_shift:mm_max_1-min_shift,i2,i3)=mm_interp(mm_min_1:mm_max_1)
           data_out(mm_min_1-min_shift:mm_max_1-min_shift,i2,i3)=mm_interp(mm_min_1-mm_min:mm_max_1-mm_max)

           deallocate(mm_interp)
        else

           !!just use nearest neightbor to unflatten
           do i1=1,n1_aux
              shift=((time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3)))*subsam
              data_out(i1,i2,i3)=data_in(i1*subsam-int(shift)-min_shift,i2,i3) !
           end do
           shift=((time_cube(n1_aux,i2,i3)-time_cube(n1_aux,ref_2,ref_3)))*subsam
           data_out(n1_aux,i2,i3)=data_in(n1_aux*subsam-ceiling(shift)-min_shift,i2,i3)
           shift=((time_cube(1,i2,i3)-time_cube(1,ref_2,ref_3)))*subsam
           data_out(1,i2,i3)=data_in(1*subsam-floor(shift)-min_shift,i2,i3)

        end if
     end do
  end do

  write(0,*) 'after loops'



  write(0,*) 'center trace:n1,n2', int(n2/2),int(n3/2)
  write(0,*) 'min_shift',min_shift
  write(0,*) 'o1',o1,'d1',d1
  !  call to_history ("n1",   n1_long)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("o1",o1+min_shift*d1/subsam)
  call to_history ("o2",o2)
  call to_history ("o3",o3)
  !   call to_history ("d1",d1/subsam) 
  call to_history ("d2",d2)
  call to_history ("d3",d3) 

  !call to_history("d1",1)
  call sep_write (data_out)

  !outwt=outwt*inwt

  call to_history("n1",n1_long,"outwt"); call to_history("n2",n2,"outwt")
  call to_history("n3",n3,"outwt")
  call to_history("d1",d1,"outwt"); call to_history("d2",d2,"outwt")
  call to_history("d3",d3,"outwt")
  call to_history("o1",o1,"outwt"); call to_history("o2",o2,"outwt")
  call to_history("o3",o3,"outwt")
  call to_history("esize",4,"outwt")
  call sep_write(outwt,"outwt")	

  call to_history("n1",n1,"indat"); call to_history("n2",n2,"indat")
  call to_history("n3",n3,"indat")
  call to_history("d1",d1,"indat"); call to_history("d2",d2,"indat")
  call to_history("d3",d3,"indat")
  call to_history("o1",o1,"indat"); call to_history("o2",02,"indat")
  call to_history("o3",o3,"indat")
  call to_history("esize",4,"indat")
  call sep_write(data_in,"indat")	


  call to_history("n1",n1,"time_cube"); call to_history("n2",n2,"time_cube")
  call to_history("n3",n3,"time_cube")
  call to_history("d1",d1,"time_cube"); call to_history("d2",d2,"time_cube")
  call to_history("d3",d3,"time_cube")
  call to_history("o1",o1,"time_cube"); call to_history("o2",o2,"time_cube")
  call to_history("o3",o3,"time_cube")
  call to_history("esize",4,"time_cube")
  call sep_write(time_cube,"time_cube")	


  deallocate(data_out)
  call sep_close()
  call exit (0)
end program Flatten_w_cube_datapreserve_sinc














