program Flatten_w_cube_datapreserve_sinc_jl  !
  !  unflatted a cube with a time shift cube
  !
  use sep
  use lint1
  use lint1_jesse
  use sorting_mod

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,it,data_out_index,subsam, shift_floor, shift_ceil, useinwt,n1_long,min_shift,counter
  integer ::mm_min, mm_max, mm_sz,n1_aux,n1_out,ref_2,ref_3,ishift,node_count,isinc,grid_node,scale_count,sinc_window
  real :: d1,d2,d3,o1,o2,o3,o1_aux,shifted_out_1,shifted_out_2,diff_shift,sinc_val,node_distance,pi
  real,   dimension(:,:), target    :: shifted_outputs,padded_input
  real,    dimension (:,:,:),   allocatable :: data_in,data_out,time_cube,outwt,inwt
  real, save, pointer, dimension(:)         ::lint_in, lint_out,shift_vec,shifted_test,mm_interp
  real, save, dimension(:),pointer                        ::coord,padded_data_in
  real                                      ::shift,iprl, diffrl,shift_diff,upwt,dwnwt,max_move,min_move,range_move
  logical :: flatten
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
  call from_aux("aux",n1_aux)  
  call from_aux("aux","o1",o1_aux)  
  !write(0,*) 'n1_aux',n1_aux
  !write(0,*) 'o1_aux',o1_aux
  !stop
  call to_history ("esize",4)
  call from_param("useinwt",useinwt,0)
  call from_param("subsample",subsam,1)

  call from_param("flatten",flatten,.true.)
  call from_param("ref_2",ref_2,n2/2)  !locate of the reference trace on the 2-axis
  call from_param("ref_3",ref_3,n3/2) !locate of the reference trace on the 3-axis
  write(0,*) 'ref_2/ref_3 coordinates of reference trace',ref_2,ref_3

  call from_history ("d1",d1,1.) ; call from_history ("o1",o1,0.)
  call from_history ("d2",d2,1.) ; call from_history ("o2",o2,0.)
  call from_history ("d3",d3,1.) ; call from_history ("o3",o3,0.)

  pi=acos(-1.)

sinc_window=50

  allocate (data_in (n1,n2,n3),time_cube(n1_aux,n2,n3),inwt(n1,n2,n3),shift_vec(n1_aux*n2*n3),shifted_outputs(2,n1_aux))  
  allocate(padded_data_in(n1_aux+2*sinc_window))
  ! read data
  ! ; data = data / maxval (cabs (data)) ! normalize


  inwt=0.
  if (useinwt==0.) then
     inwt=1.
  else 
     call sreed("inwt", inwt,4*n1*n2*n3)
     !    write(0,*) 'min of outwt', minval(outwt),maxval(outwt), sum(outwt)/size(outwt)
  endif



  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", data_in,4*n1*n2*n3)
  call sreed("aux", time_cube,4*n1_aux*n2*n3)

  data_in=data_in*inwt
  write(0,*) 'min/max/(time_slc)',minval(time_cube),maxval(time_cube)
  !data_in=0.
  !data_in(100,:,:)=1.
  !time_cube=0.

  write(0,*) 'n1/n2/n3',n1,n2,n3
  !data_out(1,:,:)=data_in(1,:,:)

  !compute range in order to preserve data
  it=1  
  do i3=1,n3
     do i2=1,n2
        do i1=1,n1_aux      
           !           if(inwt(i1,i2,i3)/=0)then
           shift_vec(it)=(i1-(time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3)))*subsam !  -5.4
           !              write(0,*) 'shift_vec',shift_vec(it) 
           it=it+1
           !       end if
        end do
     end do
  end do
  max_move=maxval(shift_vec(1:it-1))
  min_move=minval(shift_vec(1:it-1))
  min_shift=floor(min_move)
  range_move=abs(max_move-min_move)
  n1_long=ceiling(range_move)
  write(0,*) 'n1_long',n1_long


  if (flatten) then
     allocate(data_out(n1_long,n2,n3),outwt(n1_long,n2,n3))
     call to_history ("n1",   n1_long)
     call to_history ("d1",d1/subsam) 
     call to_history ("n1",   n1_long,"outwt")
     call to_history ("d1",d1/subsam,"outwt") 
     call to_history ("o1",o1+min_shift*d1/subsam)


     call to_history ("n1",   n1_long)
     call to_history ("d1",d1/subsam) 

  else
     allocate(data_out(n1_aux,n2,n3),outwt(n1,n2,n3))
     call to_history ("n1",   n1_aux)
     call to_history ("d1",d1*subsam) 
     call to_history ("o1",o1_aux)

  end if
  data_out=0.
  outwt=0.

  write(0,*) 'min_move',min_move
  write(0,*) 'max_move',max_move
  write(0,*) 'range_move',range_move
  write(0,*) 'size of data_out',size(data_out(1:,1,1)),size(data_out(1,1:,1)),size(data_out(1,1,1:))



  do i3=1,n3
     do i2=1,n2
        counter=0

        if  (flatten) then 

           padded_data_in(1:sinc_window)=data_in(sinc_window+1:1:-1,i2,i3)  !pad out the input data for sinc interpolation
           padded_data_in(sinc_window+1:n1_aux+sinc_window)=data_in(1:n1_aux,i2,i3)
          padded_data_in(n1_aux+sinc_window+1:)=data_in(n1_aux-1:n1_aux-sinc_window:-1,i2,i3) 
!!$write(0,*) 'n1_aux', n1_aux
!!$write(0,*) 'padded_data_in',padded_data_in
!!$write(0,*) 'data_in',data_in(:,i2,i3)
!!$write(0,*) 'size pad',size(padded_data_in)
!!$stop
           do i1=1,n1_aux
!!!! store the shifts
              shift=(i1-(time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3)))*subsam

              shifted_outputs(1,i1)=shift              ! store the shifts
              shifted_outputs(2,i1)=data_in(i1,i2,i3)  ! store the input data value


!!$
!!$              if (inwt(i1,i2,i3)==1) then
!!$                 outwt( mm_min-min_shift:mm_max-min_shift,i2,i3)=1.
!!$              end if


!!!! sort the shifts
              !call quick_sort(shifted_outputs,1,2,n1_aux)  !sort by shift

              !  padded_data_in(1:20)=shifted_outputs(2,1)   !pad out the input data for sinc interpolation
   !           padded_data_in(sinc_window+i1)=shifted_outputs(2,i1) 
              !   padded_data_in(n1_aux+20+1:)=shifted_outputs(2,n1_aux) 
           end do
           !write(0,*) 'data(1:30),', data_in(1:30,i2,i3)
           !write(0,*) 'pad       ,', padded_data_in(1:30)
           !stop
!!!  sinc interpolate
           !take a pair of shift outputs


           shift_loop: do ishift=1,n1_aux-1
              shifted_out_1=shifted_outputs(1,ishift); shifted_out_2=shifted_outputs(1,ishift+1)
              diff_shift=shifted_out_2-shifted_out_1 
              !data_out(min_shift-int(shifted_out_1),i2,i3)=   data_in(ishift,i2,i3)
              !now take each grid node that needs to be filled
              node_count=0
              grid_loop:do
                 grid_node=ceiling(shifted_out_1)+node_count 

                 if (grid_node==shifted_out_1) then  ! if the shifted output just happens to land on a grid node exactly then use that value and grab the next node
                    data_out(-min_shift+grid_node,i2,i3)=shifted_outputs(2,ishift)
                    node_count=node_count+1
                    cycle grid_loop
                 else if (grid_node==shifted_out_2) then  ! if the second shifted output lands on the grid node, use it and grab another pair of shifts 
                    data_out(-min_shift+grid_node,i2,i3)=shifted_outputs(2,ishift+1)
                    cycle shift_loop
                 end if
!!$if (node_count>1) then
!!$
!!$write(0,*) 'node count', node_count
!!$write(0,*) 'shift_1' ,shifted_out_1,'shift2 ',shifted_out_2
!!$ end if
                 if (grid_node<shifted_out_2) then  !if the node falls between the two shifted outputs, then interpolate it
                    node_distance=(grid_node-shifted_out_1)/diff_shift ;  !calculate the ratio of the distances from the first shifted value to the empty grid node
                    !now find the same value from the unstretched signal using sinc interpolation.
                    ! loop over 20 points on each side of the unknown signal
                    sinc_val=0
 !sinc_window=50
                   do isinc=1,sinc_window+1  !! calculate based on the 20 points to the left
!!!   ! sinc_val=sinc_val+padded_data_in(ishift-20+isinc) * (sin(pi*(floor(shifted_out_1)-20+isinc)+node_distance)
                       sinc_val=sinc_val+padded_data_in(ishift+isinc-1) * (sin(.5*pi*(real(sinc_window-isinc+1)+node_distance))/\
                       (.5*pi*(real(sinc_window-isinc+1)+node_distance)))
                    end do
                    do isinc=sinc_window+1,2*sinc_window+1 !! calculate based on the 20 points to the right
                       sinc_val=sinc_val+padded_data_in(ishift+isinc) * (sin(.5*pi*(real(-sinc_window+isinc-1)+(1.-node_distance)))/\
                       (.5*pi*(real(-sinc_window+isinc-1)+(1.-node_distance))))
                    end do
 

!!$
!!$                   scale_count=0 
!!$                    sinc_window=40
!!$                    do isinc=1,sinc_window  !! calculate based on the 20 points to the left
!!$!!!   ! sinc_val=sinc_val+padded_data_in(ishift-20+isinc) * (sin(pi*(floor(shifted_out_1)-20+isinc)+node_distance)
!!$
!!$                       if (ishift+isinc-sinc_window>0) then
!!$                          scale_count=scale_count+1
!!$                          sinc_val=sinc_val+data_in(ishift+isinc-sinc_window,i2,i3) * (sin(.5*pi*(sinc_window-isinc+node_distance))/\
!!$                          (.5*pi*(sinc_window-isinc+node_distance)))
!!$
!!$                       end if
!!$                    end do
!!$                    !          sinc_val=sinc_val/scale_count
!!$                    scale_count=0 
!!$                    do isinc=sinc_window+1,2*sinc_window !! calculate based on the 20 points to the right
!!$                       if (ishift+isinc-sinc_window<n1_aux) then
!!$                          !  write(0,*) sinc_val
!!$                          scale_count=scale_count+1
!!$                          sinc_val=sinc_val+data_in(ishift+isinc-sinc_window,i2,i3) * (sin(.5*pi*(-sinc_window+isinc+(1-node_distance)))/\
!!$                          (.5*pi*(-sinc_window+isinc+(1-node_distance))))
!!$                       end if
!!$                    end do
!!$                    !          sinc_val=sinc_val/scale_count






                    data_out(-min_shift+grid_node,i2,i3)=sinc_val
                    !      data_out(ishift+grid_node,i2,i3)=data_in(ishift,i2,i3)

                    node_count=node_count+1
                 else
                    ! exit grid_loop
                    cycle shift_loop
                 end if
              end do grid_loop

           end do shift_loop


        else

           !!just use nearest neightbor to unflatten
           do i1=1,n1_aux
              shift=((time_cube(i1,i2,i3)-time_cube(i1,ref_2,ref_3)))*subsam
              data_out(i1,i2,i3)=data_in(i1*subsam-int(shift)-min_shift,i2,i3) !

           end do
           shift=((time_cube(n1_aux,i2,i3)-time_cube(n1_aux,ref_2,ref_3)))*subsam
           data_out(n1_aux,i2,i3)=data_in(n1_aux*subsam-ceiling(shift)-min_shift,i2,i3)
           shift=((time_cube(1,i2,i3)-time_cube(1,ref_2,ref_3)))*subsam
           data_out(1,i2,i3)=data_in(1*subsam-floor(shift)-min_shift,i2,i3)

        end if
     end do
  end do

  write(0,*) 'after loops'



  write(0,*) 'center trace:n1,n2', int(n2/2),int(n3/2)
  write(0,*) 'min_shift',min_shift
  write(0,*) 'o1',o1,'d1',d1
  !  call to_history ("n1",   n1_long)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  ! call to_history ("o1",o1+min_shift*d1/subsam)
  call to_history ("o2",o2)
  call to_history ("o3",o3)
  !   call to_history ("d1",d1/subsam) 
  call to_history ("d2",d2)
  call to_history ("d3",d3) 

  !call to_history("d1",1)
  call sep_write (data_out)

  !outwt=outwt*inwt

  !call to_history("n1",n1_long,"outwt"); 
  call to_history("n2",n2,"outwt")
  call to_history("n3",n3,"outwt")
  ! call to_history("d1",d1,"outwt"); 
  call to_history("d2",d2,"outwt")
  call to_history("d3",d3,"outwt")
  call to_history("o1",o1+min_shift*d1/subsam,"outwt"); call to_history("o2",o2,"outwt")
  call to_history("o3",o3,"outwt")
  call to_history("esize",4,"outwt")
  call sep_write(outwt,"outwt")	

  call to_history("n1",n1,"indat"); call to_history("n2",n2,"indat")
  call to_history("n3",n3,"indat")
  call to_history("d1",d1,"indat"); call to_history("d2",d2,"indat")
  call to_history("d3",d3,"indat")
  call to_history("o1",o1,"indat"); call to_history("o2",02,"indat")
  call to_history("o3",o3,"indat")
  call to_history("esize",4,"indat")
  call sep_write(data_in,"indat")	


  call to_history("n1",n1,"time_cube"); call to_history("n2",n2,"time_cube")
  call to_history("n3",n3,"time_cube")
  call to_history("d1",d1,"time_cube"); call to_history("d2",d2,"time_cube")
  call to_history("d3",d3,"time_cube")
  call to_history("o1",o1,"time_cube"); call to_history("o2",o2,"time_cube")
  call to_history("o3",o3,"time_cube")
  call to_history("esize",4,"time_cube")
  call sep_write(time_cube,"time_cube")	


  !deallocate(data_out)
  call sep_close()
  call exit (0)
end program Flatten_w_cube_datapreserve_sinc_jl














