program Pick_first_break
  !Input fatten_bound and it will track the inner and outer boundaries  Jesse Lomask 10/04/05
  !Store the x, y, norm, distance
  use sep
  use sorting_mod

  implicit none

  integer				::nt, nx, ny, non_zero_mask,istatus,bnd_index
  integer				::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft
  integer                               ::radius,irx,irt,med_win
  integer                               ::diag_count, adj_count, ix_diag, it_diag, ix_new, it_new
  integer                               ::ix_old, it_old,pick_count,which_bound
  real::o1,o2,o3,d1,d2,d3,maxdat,mindat,rangedat,cutoff,dist
  real, pointer, dimension(:,:)	        ::horizon_out,mask_out
  real,  allocatable,dimension(:)        ::picks,picks_med,med_array
  real, pointer, dimension(:,:,:)	::data, norm_d,mask_in,inner_bnd,outer_bnd
  real                                  ::mask_val1,mask_val2
!!$  real, dimension(:,:,:)                ::box_grid,box_grid_colx,box_grid_coly,box_grid_row,box_grid_bnds


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

!!$  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_history("o1",o1); call from_history("o2",o2); call from_history("o3",o3);
  call from_history("d1",d1); call from_history("d2",d2); call from_history("d3",d3);

  call from_param("cutoff",cutoff,0.)
  call from_param("med_win",med_win,1)
  call from_param("which_bound",which_bound,0)
  ! ALLOCATE INPUT DATA AND MASK
  allocate(data(nt,nx,ny),mask_in(nt,nx,ny),mask_out(nt,nx),horizon_out(nt*nx,2),picks(nx))

  ! READ INPUT DATA
  call sep_read(data)

  ! READ IN INPUT MASK
  mask_in=1.
  if (exist_file("mask_in")) call sreed("mask_in", mask_in, 4*nt*nx) 

  write(0,*) maxval(data),minval(data),nt,nx,ny

  write(0,*) 'making mask'
  mask_out=0.
  !  cutoff=.00065



  find_bound: do ix=1,nx
     do it=1,nt-1
        if (data(it,ix,1)>cutoff) then
           mask_out(it,ix)=1.
           picks(ix)=real(it)

           cycle find_bound
        end if

     end do
  end do find_bound

  allocate(med_array(2*med_win+1),picks_med(nx))
  picks_med=picks

  ! MEDIAN FILTERING
  do ix=med_win+1,nx-med_win
     med_array=picks(ix-med_win:ix+med_win)
     call quick_sort(med_array,2*med_win)
     picks_med(ix)=med_array(med_win+1)
  end do
  picks=picks_med




  call to_history("n1",nt) ; call to_history("n2",nx) 
  call to_history("n3",ny)
  call to_history("d1",d1); call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("o1",o1); call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("esize",4)
  call sep_write(mask_out)

  call to_history("n1",nx,"picks.H")
  call to_history("esize",4,"picks.H")
  call sep_write(picks,"picks.H")



end program Pick_first_break

