module bessel_jml

  use sep

  implicit none
contains
  subroutine Bessel_coeff(m,n,A)
    real*8 A(0:m+n), B(0:m+n)  
    real*8 a1,b1;
    integer i,m,n
    a1 = 1.d0; b1 = 1.d0;
    do i = 1, n
       B(i - 1) = 0.d0; b1 = b1 * i; a1 = a1 / 2.d0
    end do
    b1 = a1 / b1; a1 = 1.d0
    i = 0
    do while (i <= m)  
       A(i) = a1 * b1; A(i + 1) = 0
       a1 = -a1 / ((i + 2) * (n + n + i + 2))
       i = i + 2
    end do
    a1 = a1 / 2.d0;
    do i = 0, m
       B(i + n) = A(i)
    end do
    A = B
    return
  end subroutine Bessel_coeff

end module bessel_jml
