module cosft_mod
!  use rsf


contains
  subroutine sf_cosft_2D(in, out,inv,n1,n2)
    ! Subroutine that calls Sergey Fomel's 2D COS transform.  Jesse Lomask 1/20/06

    implicit none
    !    type (file)                      :: in, out
    logical                          :: inv
    integer                          :: n1, n2, n12, i1, i2
    real, dimension (:), allocatable :: data
    real, dimension (:) :: in,out



    !  call sf_init()            ! initialize RSF
    !  in = rsf_input()
    !  out = rsf_output()

    ! if (sf_float /= gettype(in)) call sf_error("Need float type")

    !   call from_par(in,"n1",n1)  ! trace length
    !  n12 = filesize(in,0)       ! total number of samples 
    !  n2 = n12/n1                ! number of traces

    !   call from_par("inv",inv,.false.) ! forward or inverse 
    n12=n1*n2
    allocate (data (n12))
    call sf_cosft_init(n1)

    data=in
    ! read 2-D array
    !    call rsf_read(in,data)

    ! cosft over first axis
    do i2=1, n2                ! loop over traces
       i1 = (i2-1)*n1
       if (inv) then
          !    call sf_cosft_frw(data,i1,1)
          call sf_cosft_inv(data,i1,1)
       else
          call sf_cosft_frw(data,i1,1)

       end if
    end do

 
    ! Scale factor
    !data=data/((2.*(real(n1)+1))**.5)

    ! cosft over second axis

    call sf_cosft_close()
    call sf_cosft_init(n2)

    do i1=1, n1
       if (inv) then
          !     call sf_cosft_frw(data,i1-1,n1)
          call sf_cosft_inv(data,i1-1,n1)
       else
          call sf_cosft_frw(data,i1-1,n1)

       end if
    end do

  

    ! Scale factor
    !data=data/((2.*(real(n2)+1))**.5)


    out=data
    ! write 2-D array
    !    call rsf_write(out,data)

    call sf_cosft_close()
    deallocate(data)
  end subroutine sf_cosft_2D
end module cosft_mod
