module dipinteg_3D_2
  use cgstep_mod
  use sep
  use igrad3_period_eps
  !  use igrad3_2
  use solver_smp_mod
  use fft_data_mod
  !  use change_jl
  use dottest
  !  use flat_mod
  use igrad2_3d
  use igrad2_2d
  use igrad2_2d_reg
  use igrad2
  use igrad2_eps
!  use cosft_mod
  ! use fft_data_mod


  implicit none
contains
  subroutine dipintegrate_3D( rt,hh,eps_t,eps_h,n1,n2,n3,ztrans)
    integer		       :: n1,n2,n3,stat1,div,mirror_len
    integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

    complex		       :: Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
    complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
    complex                  :: kern7
    real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
    real                     :: eps_t,eps_h
    double precision         :: pi_var
    real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
    real, pointer            :: rt(:),rt_adj(:)
    real, allocatable        :: FrequRangeZ(:)
    real, allocatable        :: Outphase(:,:,:), rt_adj_3D(:,:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
    real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
    complex, allocatable     :: OutY(:,:,:),rt_adj_cmp3D(:,:,:)
    complex                  :: ztrans(:,:,:)
    real,    dimension  (2)   :: dot1,dot2

    type(fft_type)           :: fft_3d_id

    ! CREATE PI VARIABLE
    pi_var=acos(-1.)

    ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR

    call igrad2_3d_init(n1,n2,n3,eps_h)
    allocate( rt_adj(n1*n2*n3))


    ! APPLY DIVERGENCE   
    stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 


    ! RESHAPE TO 3D
    !   deallocate(rt)
    allocate ( rt_adj_3D(n1,n2,n3) )

    rt_adj_3D=reshape(rt_adj,(/n1,n2,n3/))

    deallocate(rt_adj)

    allocate (rt_adj_cmp3D(n1,n2*2,n3*2))
    rt_adj_cmp3D(1:n1,1:n2,1:n3)         = cmplx(rt_adj_3D(1:n1,1:n2,1:n3),0.)
    rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
    rt_adj_cmp3D(1:n1,n2+1:n2*2,1:2*n3)= rt_adj_cmp3D(1:n1,n2:1:-1,1:2*n3);
    deallocate(rt_adj_3D)

    n2=2*n2 
    n3=2*n3


    write(0,*) 'initializing FFTW'
    ! INITIALIZE FFTW
    fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
    write(0,*) 'after fft init',n1,n2,n3
    ! APPLY FFTW
    call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
    call clean_fft(fft_3d_id)
    write(0,*) 'after fft'

    allocate(OutY(n1,n2,n3))
    OutY=0.

    where (ztrans/=0.) OutY=rt_adj_cmp3D/ztrans
    !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

    deallocate(rt_adj_cmp3D)

    ! INVERSE FFTW
    fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
    call fft_3d_data(fft_3d_id,FFTW_BACKWARD,n1,n2,n3,OutY)
    call clean_fft(fft_3d_id)

    n2=(n2)/2  
    n3=(n3)/2

    allocate(Outphase(n1,n2,n3))

    Outphase=real(OutY(1:n1,1:n2,1:n3))

    deallocate(OutY)

    ! RESHAPE OUTPUT TO hh
    hh=reshape(Outphase,(/size(Outphase)/))

    deallocate(Outphase)
  end subroutine dipintegrate_3D

  subroutine dipintegrate_2D( rt,hh,eps_t,n1,n2,ztrans)
    integer		       :: n1,n2,n3,stat1,div,mirror_len
    integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

    complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
    complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
    complex                  :: kern7
    real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
    real                     :: eps_t,eps_h
    double precision         :: pi_var
    real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
    real, pointer            :: rt(:),rt_adj(:)
    real, allocatable        :: FrequRangeZ(:)
    real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
    real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
    complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
    complex                  :: ztrans(:,:,:)
    real,    dimension  (2)   :: dot1,dot2

    type(fft_type)           :: fft_2d_id

    ! CREATE PI VARIABLE
    pi_var=acos(-1.)

    ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
    n3=1
    !   call igrad2_3d_init(n1,n2,n3,eps_h)
    call igrad2_2d_init(n1,n2)
    allocate( rt_adj(n1*n2))
    !call dot_test (igrad2_2d_lop,100,100,dot1,dot2)
    write(0,*) 'here'
    ! APPLY DIVERGENCE   
    ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 




    stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)

!!$    call sep_write (rt_adj,"test")
!!$    call to_history ("n1",   n1,"test")
!!$    call to_history ("n2",   n2,"test")
    ! RESHAPE TO 3D
    !   deallocate(rt)
    allocate ( rt_adj_2D(n1,n2) )

    rt_adj_2D=reshape(rt_adj,(/n1,n2/))

    deallocate(rt_adj)

    allocate (rt_adj_cmp2D(n1,n2*2))
    rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
    ! rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
    rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
    deallocate(rt_adj_2D)
    n2=n2*2



    write(0,*) 'initializing FFTW'
    ! INITIALIZE FFTW
    !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
    fft_2d_id  =init_fft_2d (n1 ,n2)  
    write(0,*) 'after fft init',n1,n2,n3
    ! APPLY FFTW
    ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
    call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
    call clean_fft(fft_2d_id)
    write(0,*) 'after fft'

    allocate(OutY(n1,n2))
    OutY=0.

    where (ztrans(:,:,1)/=0.) OutY=rt_adj_cmp2D/ztrans(:,:,1)
       !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

       deallocate(rt_adj_cmp2D)

       ! INVERSE FFTW
       fft_2d_id  =init_fft_2d (n1 ,n2)  
       call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
       call clean_fft(fft_2d_id)
       write(0,*) 'after inverse fft'
       n2=n2/2
       allocate(Outphase(n1,n2))

       Outphase=real(OutY(1:n1,1:n2))

       deallocate(OutY)

       ! RESHAPE OUTPUT TO hh
       hh=reshape(Outphase,(/size(Outphase)/))

       deallocate(Outphase)
     end subroutine dipintegrate_2D

     subroutine dipintegrate_2D_pck( rt,hh,eps_t,n1,n2,ztrans)
       integer		       :: n1,n2,n3,stat1,div,mirror_len
       integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

       complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
       complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
       complex                  :: kern7
       real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
       real                     :: eps_t,eps_h
       double precision         :: pi_var
       real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
       real, pointer            :: rt(:),rt_adj(:)
       real, allocatable        :: FrequRangeZ(:)
       real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
       real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
       complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
       complex                  :: ztrans(:,:,:)
       real,    dimension  (2)   :: dot1,dot2

       type(fft_type)           :: fft_2d_id

       ! CREATE PI VARIABLE
       pi_var=acos(-1.)

       ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
       n3=1
       !   call igrad2_3d_init(n1,n2,n3,eps_h)
       !     call igrad2_2d_init(n1,n2)
       call igrad2_2d_reg_init(n1,n2,eps_t)
       allocate( rt_adj(n1*n2))
       !call dot_test (igrad2_2d_lop,100,100,dot1,dot2)
       write(0,*) 'here'
       ! APPLY DIVERGENCE   
       ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 




       !     stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)
       stat1=igrad2_2d_reg_lop(.true.,.false.,rt_adj , rt)
!!$       call sep_write (rt_adj,"test")
!!$       call to_history ("n1",   n1,"test")
!!$       call to_history ("n2",   n2,"test")
!!$       ! RESHAPE TO 3D
       !   deallocate(rt)
       allocate ( rt_adj_2D(n1,n2) )

       rt_adj_2D=reshape(rt_adj,(/n1,n2/))

       deallocate(rt_adj)

       allocate (rt_adj_cmp2D(n1*2,n2*2))
       rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
       ! rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
       rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
       rt_adj_cmp2D(n1+1:n1*2,1:n2*2)= rt_adj_cmp2D(n1:1:-1,1:n2*2)
       deallocate(rt_adj_2D)
       n2=n2*2
       n1=n1*2


       write(0,*) 'initializing FFTW'
       ! INITIALIZE FFTW
       !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
       fft_2d_id  =init_fft_2d (n1 ,n2)  
       write(0,*) 'after fft init',n1,n2,n3
       ! APPLY FFTW
       ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
       call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
       call clean_fft(fft_2d_id)
       write(0,*) 'after fft'

       allocate(OutY(n1,n2))
       OutY=0.

       where (ztrans(:,:,1)/=0.) OutY=rt_adj_cmp2D/ztrans(:,:,1)
          !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

          deallocate(rt_adj_cmp2D)

          ! INVERSE FFTW
          fft_2d_id  =init_fft_2d (n1 ,n2)  
          call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
          call clean_fft(fft_2d_id)
          write(0,*) 'after inverse fft'
          n2=n2/2
          n1=n1/2
          allocate(Outphase(n1,n2))

          Outphase=real(OutY(1:n1,1:n2))

          deallocate(OutY)

          ! RESHAPE OUTPUT TO hh
          hh=reshape(Outphase,(/size(Outphase)/))

          deallocate(Outphase)
        end subroutine dipintegrate_2D_pck

        subroutine dipintegrate_2D_reg( rt,hh,eps_t,n1,n2,ztrans)
          integer		       :: n1,n2,n3,stat1,div,mirror_len
          integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

          complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
          complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
          complex                  :: kern7
          real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
          real                     :: eps_t,eps_h
          double precision         :: pi_var
          real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
          real, pointer            :: rt(:),rt_adj(:)
          real, allocatable        :: FrequRangeZ(:)
          real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
          real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
          complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
          complex                  :: ztrans(:,:,:)
          real,    dimension  (2)   :: dot1,dot2

          type(fft_type)           :: fft_2d_id

          ! CREATE PI VARIABLE
          pi_var=acos(-1.)

          ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
          n3=1
          !   call igrad2_3d_init(n1,n2,n3,eps_h)
          !   call igrad2_2d_init(n1,n2)
          call igrad2_2d_reg_init(n1,n2,eps_t)
          allocate( rt_adj(n1*n2))
          !call dot_test (igrad2_2d_lop,100,100,dot1,dot2)
          write(0,*) 'eps_t',eps_t
          call dot_test (igrad2_2d_reg_lop,n1*n2,n1*n2*2,dot1,dot2)

          write(0,*) 'here'
          ! APPLY DIVERGENCE   
          ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 




          !       stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)
          stat1=igrad2_2d_reg_lop(.true.,.false.,rt_adj , rt)
!!$          call sep_write (rt_adj,"test")
!!$          call to_history ("n1",   n1,"test")
!!$          call to_history ("n2",   n2,"test")
          ! RESHAPE TO 3D
          !   deallocate(rt)
          allocate ( rt_adj_2D(n1,n2) )

          rt_adj_2D=reshape(rt_adj,(/n1,n2/))

          deallocate(rt_adj)

          allocate (rt_adj_cmp2D(n1*2,n2*2))
          rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
          ! rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
          rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
          rt_adj_cmp2D(n1+1:n1*2,1:n2*2)= rt_adj_cmp2D(n1:1:-1,1:n2*2)
          deallocate(rt_adj_2D)
          n2=n2*2
          n1=n1*2


          write(0,*) 'initializing FFTW'
          ! INITIALIZE FFTW
          !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
          fft_2d_id  =init_fft_2d (n1 ,n2)  
          write(0,*) 'after fft init',n1,n2,n3
          ! APPLY FFTW
          ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
          call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
          call clean_fft(fft_2d_id)
          write(0,*) 'after fft'

          allocate(OutY(n1,n2))
          OutY=0.

          !   where (ztrans(:,:,1)/=0.) OutY=rt_adj_cmp2D/ztrans(:,:,1)
          where (ztrans(:,:,1)/=0.) OutY=(rt_adj_cmp2D*ztrans(:,:,1))/(ztrans(:,:,1)*ztrans(:,:,1)+.000001)

             !where (ztrans(:,:,1)>0.01) OutY=(rt_adj_cmp2D*ztrans(:,:,1))/(ztrans(:,:,1)*ztrans(:,:,1)+.000001)
             !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

             deallocate(rt_adj_cmp2D)

             ! INVERSE FFTW
             fft_2d_id  =init_fft_2d (n1 ,n2)  
             call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
             call clean_fft(fft_2d_id)
             write(0,*) 'after inverse fft'
             n2=n2/2
             n1=n1/2
             allocate(Outphase(n1,n2))

             Outphase=real(OutY(1:n1,1:n2))

             deallocate(OutY)

             ! RESHAPE OUTPUT TO hh
             hh=reshape(Outphase,(/size(Outphase)/))

             deallocate(Outphase)
           end subroutine dipintegrate_2D_reg

!!$        subroutine dipintegrate_2D_fftw3( rt,hh,eps_t,n1,n2,ztrans)
!!$          integer		       :: n1,n2,n3,stat1,div,mirror_len
!!$          integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
!!$
!!$          complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
!!$          complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
!!$          complex                  :: kern7
!!$          real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
!!$          real                     :: eps_t,eps_h
!!$          double precision         :: pi_var
!!$          real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
!!$          real, pointer            :: rt(:),rt_adj(:)
!!$          real, allocatable        :: FrequRangeZ(:)
!!$          real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
!!$          real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
!!$          complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
!!$          complex                  :: ztrans(:,:,:)
!!$          real,    dimension  (2)   :: dot1,dot2
!!$          type(fft_type)           :: fft_2d_id
!!$          !          complex, double          ::arr(n1,n2,1)
!!$          integer*8                :: plan
!!$
!!$
!!$
!!$          ! CREATE PI VARIABLE
!!$          pi_var=acos(-1.)
!!$
!!$          ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
!!$          n3=1
!!$          !   call igrad2_3d_init(n1,n2,n3,eps_h)
!!$          !   call igrad2_2d_init(n1,n2)
!!$          call igrad2_2d_reg_init(n1,n2,eps_t)
!!$          allocate( rt_adj(n1*n2))
!!$          !call dot_test (igrad2_2d_lop,100,100,dot1,dot2)
!!$          write(0,*) 'eps_t',eps_t
!!$          call dot_test (igrad2_2d_reg_lop,n1*n2,n1*n2*2,dot1,dot2)
!!$
!!$          write(0,*) 'here'
!!$          ! APPLY DIVERGENCE   
!!$          ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 
!!$
!!$
!!$
!!$
!!$          !       stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)
!!$          stat1=igrad2_2d_reg_lop(.true.,.false.,rt_adj , rt)
!!$          call sep_write (rt_adj,"test")
!!$          call to_history ("n1",   n1,"test")
!!$          call to_history ("n2",   n2,"test")
!!$          ! RESHAPE TO 3D
!!$          !   deallocate(rt)
!!$          allocate ( rt_adj_2D(n1,n2) )
!!$
!!$          rt_adj_2D=reshape(rt_adj,(/n1,n2/))
!!$
!!$          deallocate(rt_adj)
!!$
!!$          allocate (rt_adj_cmp2D(n1*2,n2*2))
!!$          rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
!!$          ! rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
!!$          rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
!!$          rt_adj_cmp2D(n1+1:n1*2,1:n2*2)= rt_adj_cmp2D(n1:1:-1,1:n2*2)
!!$          deallocate(rt_adj_2D)
!!$          n2=n2*2
!!$          n1=n1*2
!!$
!!$
!!$          write(0,*) 'initializing FFTW'
!!$          ! INITIALIZE FFTW
!!$          !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
!!$          !          fft_2d_id  =init_fft_2d (n1 ,n2)  
!!$          write(0,*) 'after fft init',n1,n2,n3
!!$          ! APPLY FFTW
!!$          ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
!!$          !          call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
!!$          !          call clean_fft(fft_2d_id)
!!$
!!$          call dfftw_plan_dft_3d(plan,n1,n2,n3,rt_adj_cmp2D ,rt_adj_cmp2D,FFTW_FORWARD,FFTW_ESTIMATE)
!!$          call dfftw_execute(plan)
!!$          call dfftw_destroy_plan(plan) 
!!$
!!$          write(0,*) 'after fft'
!!$
!!$          allocate(OutY(n1,n2))
!!$          OutY=0.
!!$
!!$          !   where (ztrans(:,:,1)/=0.) OutY=rt_adj_cmp2D/ztrans(:,:,1)
!!$          where (ztrans(:,:,1)/=0.) OutY=(rt_adj_cmp2D*ztrans(:,:,1))/(ztrans(:,:,1)*ztrans(:,:,1)+.000001)
!!$             !where (ztrans(:,:,1)>0.01) OutY=(rt_adj_cmp2D*ztrans(:,:,1))/(ztrans(:,:,1)*ztrans(:,:,1)+.000001)
!!$             !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)
!!$
!!$             deallocate(rt_adj_cmp2D)
!!$
!!$             ! INVERSE FFTW
!!$             !        fft_2d_id  =init_fft_2d (n1 ,n2)  
!!$             !        call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
!!$             !        call clean_fft(fft_2d_id)
!!$             call dfftw_plan_dft_3d(plan,n1,n2,n3,OutY ,OutY,FFTW_BACKWARD,FFTW_ESTIMATE)
!!$             call dfftw_execute(plan)
!!$             call dfftw_destroy_plan(plan) 
!!$
!!$
!!$
!!$
!!$             write(0,*) 'after inverse fft'
!!$             n2=n2/2
!!$             n1=n1/2
!!$             allocate(Outphase(n1,n2))
!!$
!!$             Outphase=real(OutY(1:n1,1:n2))
!!$
!!$             deallocate(OutY)
!!$
!!$             ! RESHAPE OUTPUT TO hh
!!$             hh=reshape(Outphase,(/size(Outphase)/))
!!$
!!$             deallocate(Outphase)
!!$           end subroutine dipintegrate_2D_fftw3

!!$           subroutine dipintegrate_2D_cos_trans( rt,hh,eps_t,n1,n2,cos_trans)
!!$             integer		       :: n1,n2,n3,stat1,div,mirror_len
!!$             integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist 
!!$             real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
!!$             real                     :: eps_t,eps_h
!!$             double precision         :: pi_var
!!$             real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
!!$             real, pointer            :: rt(:),rt_adj(:)
!!$             real, allocatable        :: FrequRangeZ(:)
!!$             real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
!!$             real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
!!$             complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
!!$             real                     :: cos_trans(:,:,:)
!!$             real,    dimension  (2)  :: dot1,dot2
!!$  !           complex, double,dimension(n1*n2):: in, out
!!$
!!$             integer*8                :: plan
!!$
!!$
!!$
!!$             !          type(fft_type)           :: fft_2d_id
!!$
!!$             ! CREATE PI VARIABLE
!!$             pi_var=acos(-1.)
!!$
!!$             ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
!!$             n3=1
!!$             !   call igrad2_3d_init(n1,n2,n3,eps_h)
!!$             !   call igrad2_2d_init(n1,n2)
!!$             call igrad2_2d_reg_init(n1,n2,eps_t)
!!$             allocate( rt_adj(n1*n2))
!!$             !call dot_test (igrad2_2d_lop,100,100,dot1,dot2)
!!$             write(0,*) 'eps_t',eps_t
!!$             call dot_test (igrad2_2d_reg_lop,n1*n2,n1*n2*2,dot1,dot2)
!!$
!!$             write(0,*) 'here'
!!$             ! APPLY DIVERGENCE   
!!$             ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 
!!$
!!$
!!$
!!$
!!$             !       stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)
!!$             stat1=igrad2_2d_reg_lop(.true.,.false.,rt_adj , rt)
!!$             call sep_write (rt_adj,"test")
!!$             call to_history ("n1",   n1,"test")
!!$             call to_history ("n2",   n2,"test")
!!$             ! RESHAPE TO 3D
!!$             !   deallocate(rt)
!!$             allocate ( rt_adj_2D(n1,n2) )
!!$
!!$             rt_adj_2D=reshape(rt_adj,(/n1,n2/))
!!$
!!$             deallocate(rt_adj)
!!$
!!$             allocate (rt_adj_cmp2D(n1*2,n2*2))
!!$             rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
!!$             ! rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
!!$             rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
!!$             rt_adj_cmp2D(n1+1:n1*2,1:n2*2)= rt_adj_cmp2D(n1:1:-1,1:n2*2)
!!$             deallocate(rt_adj_2D)
!!$             n2=n2*2
!!$             n1=n1*2
!!$
!!$
!!$             write(0,*) 'initializing FFTW'
!!$             ! INITIALIZE FFTW
!!$             !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
!!$             fft_2d_id  =init_fft_2d (n1 ,n2)  
!!$             write(0,*) 'after fft init',n1,n2,n3
!!$             ! APPLY FFTW
!!$             ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
!!$             call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
!!$             call clean_fft(fft_2d_id)
!!$             write(0,*) 'after fft'
!!$
!!$             allocate(OutY(n1,n2))
!!$             OutY=0.
!!$
!!$             !   where (ztrans(:,:,1)/=0.) OutY=rt_adj_cmp2D/ztrans(:,:,1)
!!$             where (ztrans(:,:,1)/=0.) OutY=(rt_adj_cmp2D*ztrans(:,:,1))/(ztrans(:,:,1)*ztrans(:,:,1)+.000001)
!!$                !where (ztrans(:,:,1)>0.01) OutY=(rt_adj_cmp2D*ztrans(:,:,1))/(ztrans(:,:,1)*ztrans(:,:,1)+.000001)
!!$                !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)
!!$
!!$                deallocate(rt_adj_cmp2D)
!!$
!!$                ! INVERSE FFTW
!!$                fft_2d_id  =init_fft_2d (n1 ,n2)  
!!$                call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
!!$                call clean_fft(fft_2d_id)
!!$                write(0,*) 'after inverse fft'
!!$                n2=n2/2
!!$                n1=n1/2
!!$                allocate(Outphase(n1,n2))
!!$
!!$                Outphase=real(OutY(1:n1,1:n2))
!!$
!!$                deallocate(OutY)
!!$
!!$                ! RESHAPE OUTPUT TO hh
!!$                hh=reshape(Outphase,(/size(Outphase)/))
!!$
!!$                deallocate(Outphase)
!!$              end subroutine dipintegrate_2D_reg



           subroutine dipintegrate_timeslice( rt,hh,n1,n2,ztrans,eps_h)
             integer		       :: n1,n2,n3,stat1,div,mirror_len
             integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

             complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
             complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
             complex                  :: kern7
             real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
             real                     :: eps_t,eps_h
             double precision         :: pi_var
             real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
             real, pointer            :: rt(:),rt_adj(:)
             real, allocatable        :: FrequRangeZ(:)
             real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
             real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
             complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
             complex                  :: ztrans(:,:,:)
             real,    dimension  (2)   :: dot1,dot2

             type(fft_type)           :: fft_2d_id

             ! CREATE PI VARIABLE
             pi_var=acos(-1.)

             ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
             n3=1
             !   call igrad2_3d_init(n1,n2,n3,eps_h)
             call igrad2_init(n1,n2)
             !   call igrad2_eps_init(n1,n2,eps_h**2)
             allocate( rt_adj(n1*n2))
             !   call dot_test (igrad2_eps_lop,n1*n2,2*n1*n2,dot1,dot2)

             ! APPLY DIVERGENCE   
             ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 

             rt(n1*n2+1:)=rt(n1*n2+1:)*(eps_h**2)
             stat1=igrad2_lop(.true.,.false.,rt_adj , rt)
             !  stat1=igrad2_eps_lop(.true.,.false.,rt_adj , rt)

!!$             call sep_write (rt_adj,"test")
!!$             call to_history ("n1",   n1,"test")
!!$             call to_history ("n2",   n2,"test")
             ! RESHAPE TO 3D
             !   deallocate(rt)
             allocate ( rt_adj_2D(n1,n2) )

             rt_adj_2D=reshape(rt_adj,(/n1,n2/))

             deallocate(rt_adj)

             allocate (rt_adj_cmp2D(n1*2,n2*2))
             rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
             rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
             rt_adj_cmp2D(n1+1:n1*2,1:n2*2)= rt_adj_cmp2D(n1:1:-1,1:n2*2)

             deallocate(rt_adj_2D)
             n2=n2*2
             n1=n1*2



             !       write(0,*) 'initializing FFTW'
             ! INITIALIZE FFTW
             !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
             fft_2d_id  =init_fft_2d (n1 ,n2)  
             !       write(0,*) 'after fft init',n1,n2,n3
             ! APPLY FFTW
             ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
             call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
             call clean_fft(fft_2d_id)
             !     write(0,*) 'after fft'

             allocate(OutY(n1,n2))
             OutY=0.

             where (real(ztrans(1,:,:))/=0.) OutY=rt_adj_cmp2D/ztrans(1,:,:)

                !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

                deallocate(rt_adj_cmp2D)

                ! INVERSE FFTW
                fft_2d_id  =init_fft_2d (n1 ,n2)  
                call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
                call clean_fft(fft_2d_id)
                !    write(0,*) 'after inverse fft'
                n2=n2/2
                n1=n1/2
                allocate(Outphase(n1,n2))

                Outphase=real(OutY(1:n1,1:n2))

                deallocate(OutY)

                ! RESHAPE OUTPUT TO hh
                hh=reshape(Outphase,(/size(Outphase)/))

                deallocate(Outphase)
              end subroutine dipintegrate_timeslice

              subroutine dipintegrate_timeslice_full( rt_adj,hh,n1,n2,ztrans,eps_h)
                integer		       :: n1,n2,n3,stat1,div,mirror_len
                integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

                complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
                complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
                complex                  :: kern7
                real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
                real                     :: eps_t,eps_h
                double precision         :: pi_var
                real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
                real                     :: rt_adj(:)

                real, allocatable        :: FrequRangeZ(:)
                real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
                real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
                complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
                complex                  :: ztrans(:,:,:)
                real,    dimension  (2)   :: dot1,dot2

                type(fft_type)           :: fft_2d_id

                ! CREATE PI VARIABLE
                pi_var=acos(-1.)

                ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
                n3=1
                !   call igrad2_3d_init(n1,n2,n3,eps_h)
!!$          call igrad2_init(n1,n2)
!!$          !   call igrad2_eps_init(n1,n2,eps_h**2)
!!$          allocate( rt_adj(n1*n2))
!!$          !   call dot_test (igrad2_eps_lop,n1*n2,2*n1*n2,dot1,dot2)
!!$
!!$          ! APPLY DIVERGENCE   
!!$          ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 
!!$
!!$          rt(n1*n2+1:)=rt(n1*n2+1:)*(eps_h**2)
!!$          stat1=igrad2_lop(.true.,.false.,rt_adj , rt)
!!$          !  stat1=igrad2_eps_lop(.true.,.false.,rt_adj , rt)
!!$
!!$          call sep_write (rt_adj,"test")
!!$          call to_history ("n1",   n1,"test")
!!$          call to_history ("n2",   n2,"test")
                ! RESHAPE TO 3D
                !   deallocate(rt)
                allocate ( rt_adj_2D(n1,n2) )

                rt_adj_2D=reshape(rt_adj,(/n1,n2/))

                !deallocate(rt_adj)

                allocate (rt_adj_cmp2D(n1*2,n2*2))
                rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
                rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
                rt_adj_cmp2D(n1+1:n1*2,1:n2*2)= rt_adj_cmp2D(n1:1:-1,1:n2*2)

                deallocate(rt_adj_2D)
                n2=n2*2
                n1=n1*2



                !       write(0,*) 'initializing FFTW'
                ! INITIALIZE FFTW
                !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
                fft_2d_id  =init_fft_2d (n1 ,n2)  
                !       write(0,*) 'after fft init',n1,n2,n3
                ! APPLY FFTW
                ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
                call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
                call clean_fft(fft_2d_id)
                !     write(0,*) 'after fft'


!!$                call sep_write (real(rt_adj_cmp2D) ,"rt_adj_cmp2D") 
!!$                call to_history ("n1",   n1,"rt_adj_cmp2D")
!!$                call to_history ("n2",   n2,"rt_adj_cmp2D")

                allocate(OutY(n1,n2))
                OutY=0.

                ! where (real(ztrans(1,:,:))/=0.) OutY=rt_adj_cmp2D/ztrans(1,:,:)
                !  where (ztrans(1,:,:)/=0.) OutY=(rt_adj_cmp2D*ztrans(1,:,:))/(ztrans(1,:,:)*ztrans(1,:,:)+.000000001)
                where (real(ztrans(1,:,:))>.000001) OutY=(rt_adj_cmp2D*ztrans(1,:,:))/(ztrans(1,:,:)*ztrans(1,:,:)+.000000001)
                   !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

                   deallocate(rt_adj_cmp2D)

                   ! INVERSE FFTW
                   fft_2d_id  =init_fft_2d (n1 ,n2)  
                   call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
                   call clean_fft(fft_2d_id)
                   !    write(0,*) 'after inverse fft'
                   n2=n2/2
                   n1=n1/2
                   allocate(Outphase(n1,n2))

                   Outphase=real(OutY(1:n1,1:n2))

                   deallocate(OutY)

                   ! RESHAPE OUTPUT TO hh
                   hh=reshape(Outphase,(/size(Outphase)/))

                   deallocate(Outphase)
                 end subroutine dipintegrate_timeslice_full

                 subroutine dipintegrate_timeslice_cosft( rt_adj,hh,n1,n2,cos_trans,eps_h)
                   integer		       :: n1,n2,n3,stat1,div,mirror_len
                   integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

                   complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
                   complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
                   complex                  :: kern7
                   real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
                   real                     :: eps_t,eps_h
                   double precision         :: pi_var
                   real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
                   real                     :: rt_adj(:)

                   real, allocatable        :: FrequRangeZ(:)
                   real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:),rt_adj_in(:),rt_adj_out(:)
                   real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:),OutY(:,:)
                   complex, allocatable     :: rt_adj_cmp2D(:,:)
                   !                complex                  :: ztrans(:,:,:)
                   real                     :: cos_trans(:,:,:)
                   real, allocatable        ::cos_trans2(:,:)
                   real,    dimension  (2)   :: dot1,dot2

                   type(fft_type)           :: fft_2d_id

                   ! CREATE PI VARIABLE
                   pi_var=acos(-1.)

                   ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
                   n3=1
                   !   call igrad2_3d_init(n1,n2,n3,eps_h)

                   allocate ( rt_adj_2D(n1,n2) )

                   rt_adj_2D=reshape(rt_adj,(/n1,n2/))

                   !deallocate(rt_adj)

                   allocate (rt_adj_in(n1*n2),rt_adj_out(n1*n2))

                   write(0,*) 'after fft init',n1,n2,n3

                   rt_adj_in=reshape(rt_adj_2D,(/n1*n2/))
    !           !    call sf_cosft_2D(rt_adj_in,rt_adj_out,.false.,n1,n2)
                   rt_adj_2D=reshape(rt_adj_out,(/n1,n2/))

!!$                   call sep_write ((rt_adj_2D) ,"rt_adj_2D") 
!!$                   call to_history ("n1",   n1,"rt_adj_2D")
!!$                   call to_history ("n2",   n2,"rt_adj_2D")


                   !rt_adj_2D=(rt_adj_2D)/(n1*n2)
                   !rt_adj_2D=(rt_adj_2D)*(4./((real(n1)*real(n2))-real(n1)-real(n2)+1.))

                   !rt_adj_2D=(rt_adj_2D)*(1./(4*(real(n1)-1)*(real(n2)-1))**.5)

                   !rt_adj_2D=(rt_adj_2D)*(1./(4.*(real(n1)-1)*(real(n2)-1))**.5)

                   !rt_adj_2D=(rt_adj_2D)*(1./(real(n1)*real(n2)))

                   allocate(OutY(n1,n2))
                   OutY=0.

                   ! where (real(ztrans(1,:,:))/=0.) OutY=rt_adj_cmp2D/ztrans(1,:,:)
                   !  where (ztrans(1,:,:)/=0.) OutY=(rt_adj_cmp2D*ztrans(1,:,:))/(ztrans(1,:,:)*ztrans(1,:,:)+.000000001)
                   !    where (real(ztrans(1,:,:))>.00001) OutY=(rt_adj_cmp2D*real(ztrans(1,:,:)))/(real(ztrans(1,:,:))*real(ztrans(1,:,:))+.000000001)
                   !   where (cos_trans(1,:,:)>.00001) OutY=(rt_adj_2D*cos_trans(1,:,:))/(cos_trans(1,:,:)*cos_trans(1,:,:)+.000000001)
                   !  where (cos_trans(1,:,:)>.000001) OutY=(rt_adj_2D*cos_trans(1,:,:))/(cos_trans(1,:,:)*cos_trans(1,:,:)+.000000001)


                   allocate(cos_trans2(n1,n2))
                   !cos_trans2(:,:)=cos_trans(1,n1:1:-1,:)
                   !cos_trans2(:,:)=cos_trans(1,n1:1:-1,n2:1:-1)
                   !cos_trans2(:,:)=cos_trans(1,:,n2:1:-1)
                   cos_trans2(:,:)=cos_trans(1,:,:)
                   where (cos_trans2(:,:)>.00000000001) OutY=(rt_adj_2D*cos_trans2(:,:))/(cos_trans2(:,:)*cos_trans2(:,:)+.000000000001)
                      deallocate(cos_trans2)

                      !  where (cos_trans(1,:,:)>.00000000001) OutY=(rt_adj_2D*cos_trans(1,:,:))/(cos_trans(1,:,:)*cos_trans(1,:,:)+.000000000001)
                      ! where (real(ztrans(1,:,:))>.00001) OutY=(rt_adj_2D)/real(ztrans(1,:,:))
                      !OutY=rt_adj_2D 

                      !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

                      deallocate(rt_adj_2D)


                      rt_adj_in=reshape(OutY,(/n1*n2/))
                 !     call sf_cosft_2D(rt_adj_in,rt_adj_out,.true.,n1,n2)
                      OutY=reshape(rt_adj_out,(/n1,n2/))

                      !OutY=(OutY)*(4./((real(n1)*real(n2))-real(n1)-real(n2)+1.))
                      !OutY=(OutY)*(2./((real(n1)*real(n2))))
                      !OutY=OutY/(n1*n2)
                      !OutY=(OutY)*(1./(real(n1)+real(n2)))

                      !OutY=(OutY)*(1./(4*(real(n1)-1)*(real(n2)-1))**.5)
                      !OutY=(OutY)*(1./(4.*(real(n1)-1)*(real(n2)-1))**.5)

                      !OutY=(OutY)*(1./(real(n1)*real(n2)))

                      !    write(0,*) 'after inverse fft'
                      !  n2=n2/2
                      !  n1=n1/2
                      allocate(Outphase(n1,n2))

                      Outphase=OutY(1:n1,1:n2)

                      deallocate(OutY)

                      ! RESHAPE OUTPUT TO hh
                      hh=reshape(Outphase,(/size(Outphase)/))

                      deallocate(Outphase,rt_adj_in,rt_adj_out)
                    end subroutine dipintegrate_timeslice_cosft

                    subroutine dipintegrate_timeslice_cosft_mirr( rt_adj,hh,n1,n2,cos_trans,eps_h)
                      integer		       :: n1,n2,n3,stat1,div,mirror_len
                      integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

                      complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
                      complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
                      complex                  :: kern7
                      real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
                      real                     :: eps_t,eps_h
                      double precision         :: pi_var
                      real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
                      real                     :: rt_adj(:)

                      real, allocatable        :: FrequRangeZ(:)
                      real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:),rt_adj_in(:),rt_adj_out(:)
                      real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:),OutY(:,:)
                      complex, allocatable     :: rt_adj_cmp2D(:,:)
                      !                complex                  :: ztrans(:,:,:)
                      real                     :: cos_trans(:,:,:)
                      real,    dimension  (2)   :: dot1,dot2

                      type(fft_type)           :: fft_2d_id

                      ! CREATE PI VARIABLE
                      pi_var=acos(-1.)

                      ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
                      n3=1
                      !   call igrad2_3d_init(n1,n2,n3,eps_h)

                      allocate ( rt_adj_2D(n1*2,n2*2) )
!!$
!!$                   rt_adj_2D(1:n1,1:n2)  =reshape(rt_adj,(/n1,n2/))
!!$                   rt_adj_2D(1:n1,n2+1:n2*2)    = rt_adj_2D(1:n1,n2:1:-1)
!!$                   rt_adj_2D(n1+1:n1*2,1:n2*2)  = rt_adj_2D(n1:1:-1,1:n2*2)

                      rt_adj_2D(n1+1:n1*2,n2+1:n2*2)  =reshape(rt_adj,(/n1,n2/))
                      rt_adj_2D(1:n1,n2+1:n2*2)    = rt_adj_2D(n1*2:n1+1:-1,n2+1:n2*2)
                      rt_adj_2D(1:n1*2,1:n2)  = rt_adj_2D(1:n1*2,n2*2:n2+1:-1)

                      n2=n2*2
                      n1=n1*2


!!$                      call sep_write (rt_adj_2D ,"rt_adj_2D") 
!!$                      call to_history ("n1",   n1,"rt_adj_2D")
!!$                      call to_history ("n2",   n2,"rt_adj_2D")

                      !deallocate(rt_adj)

                      allocate (rt_adj_in(n1*n2),rt_adj_out(n1*n2))

                      write(0,*) 'after fft init',n1,n2,n3
                      write(0,*) 'sum in', sum((rt_adj_2d*rt_adj_2d)**.5)
                      rt_adj_in=reshape(rt_adj_2D,(/n1*n2/))
                !      call sf_cosft_2D(rt_adj_in,rt_adj_out,.false.,n1,n2)
                      rt_adj_2D=reshape(rt_adj_out,(/n1,n2/))
                      !rt_adj_2D=(rt_adj_2D)/(n1*n2)
                      !rt_adj_2D=(rt_adj_2D)*(4./((real(n1)*real(n2))-real(n1)-real(n2)+1.))

                      !rt_adj_2D=(rt_adj_2D)*(1./(4*(real(n1)-1)*(real(n2)-1))**.5)

                      !       rt_adj_2D=(rt_adj_2D)*(1./(4.*(real(n1)-1)*(real(n2)-1))**.5)

                      !rt_adj_2D=(rt_adj_2D)*(1./(real(n1)*real(n2)))
                      !   rt_adj_2D=(rt_adj_2D)*(1./(real(n1)+real(n2)))
                      allocate(OutY(n1,n2))
                      OutY=0.

                      ! where (real(ztrans(1,:,:))/=0.) OutY=rt_adj_cmp2D/ztrans(1,:,:)
                      !  where (ztrans(1,:,:)/=0.) OutY=(rt_adj_cmp2D*ztrans(1,:,:))/(ztrans(1,:,:)*ztrans(1,:,:)+.000000001)
                      !    where (real(ztrans(1,:,:))>.00001) OutY=(rt_adj_cmp2D*real(ztrans(1,:,:)))/(real(ztrans(1,:,:))*real(ztrans(1,:,:))+.000000001)
                      !   where (cos_trans(1,:,:)>.00001) OutY=(rt_adj_2D*cos_trans(1,:,:))/(cos_trans(1,:,:)*cos_trans(1,:,:)+.000000001)
                      !            where (cos_trans(1,:,:)>.000001) OutY=(rt_adj_2D*cos_trans(1,:,:))/(cos_trans(1,:,:)*cos_trans(1,:,:)+.000000001)

                      where (cos_trans(1,:,:)/=0.) OutY=(rt_adj_2D*cos_trans(1,:,:))/(cos_trans(1,:,:)*cos_trans(1,:,:)+.000000001)

                         do i1=1,n1
                            do i2=1,n2
                               if (cos_trans(1,i1,i2)>.00001) then
                                  !  OutY(i1,i2)=(rt_adj_2D(i1,i2)*cos_trans(1,i1,i2))/(cos_trans(1,i1,i2)*cos_trans(1,i1,i2)+.00001)
                                  !         OutY(i1,i2)=rt_adj_2D(i1,i2)/cos_trans(1,i1,i2)
                               end if
                            end do
                         end do


                         ! where (real(ztrans(1,:,:))>.00001) OutY=(rt_adj_2D)/real(ztrans(1,:,:))
                         !
                         !                   OutY=rt_adj_2D 

                         !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

                         deallocate(rt_adj_2D)


                         rt_adj_in=reshape(OutY,(/n1*n2/))
                   !      call sf_cosft_2D(rt_adj_in,rt_adj_out,.true.,n1,n2)
                         OutY=reshape(rt_adj_out,(/n1,n2/))

                         !OutY=(OutY)*(4./((real(n1)*real(n2))-real(n1)-real(n2)+1.))
                         !OutY=(OutY)*(2./((real(n1)*real(n2))))
                         !OutY=OutY/(n1*n2)
                         !OutY=(OutY)*(1./(real(n1)+real(n2)))

                         !OutY=(OutY)*(1./(4*(real(n1)-1)*(real(n2)-1))**.5)
                         !         OutY=(OutY)*(1./(4.*(real(n1)-1)*(real(n2)-1))**.5)

                         !  OutY=(OutY)*(1./(real(n1)+real(n2)))
                         write(0,*) 'sum out', sum((OutY*OutY)**.5)
                         !    write(0,*) 'after inverse fft'
                         n2=n2/2
                         n1=n1/2
                         allocate(Outphase(n1,n2))

                         Outphase=OutY(1:n1,1:n2)

                         deallocate(OutY)

                         ! RESHAPE OUTPUT TO hh
                         hh=reshape(Outphase,(/size(Outphase)/))

                         deallocate(Outphase,rt_adj_in,rt_adj_out)
                       end subroutine dipintegrate_timeslice_cosft_mirr

                       subroutine dipintegrate_timeslice_nomirror( rt_adj,hh,n1,n2,ztrans,eps_h)
                         integer		       :: n1,n2,n3,stat1,div,mirror_len
                         integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

                         complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
                         complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
                         complex                  :: kern7
                         real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
                         real                     :: eps_t,eps_h
                         double precision         :: pi_var
                         real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
                         real                     :: rt_adj(:)

                         real, allocatable        :: FrequRangeZ(:)
                         real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
                         real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
                         complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
                         complex                  :: ztrans(:,:,:)
                         real,    dimension  (2)   :: dot1,dot2

                         type(fft_type)           :: fft_2d_id

                         ! CREATE PI VARIABLE
                         pi_var=acos(-1.)

                         ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
                         n3=1
                         !   call igrad2_3d_init(n1,n2,n3,eps_h)
!!$          call igrad2_init(n1,n2)
!!$          !   call igrad2_eps_init(n1,n2,eps_h**2)
!!$          allocate( rt_adj(n1*n2))
!!$          !   call dot_test (igrad2_eps_lop,n1*n2,2*n1*n2,dot1,dot2)
!!$
!!$          ! APPLY DIVERGENCE   
!!$          ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 
!!$
!!$          rt(n1*n2+1:)=rt(n1*n2+1:)*(eps_h**2)
!!$          stat1=igrad2_lop(.true.,.false.,rt_adj , rt)
!!$          !  stat1=igrad2_eps_lop(.true.,.false.,rt_adj , rt)
!!$
!!$          call sep_write (rt_adj,"test")
!!$          call to_history ("n1",   n1,"test")
!!$          call to_history ("n2",   n2,"test")
                         ! RESHAPE TO 3D
                         !   deallocate(rt)
                         allocate ( rt_adj_2D(n1,n2) )

                         rt_adj_2D=reshape(rt_adj,(/n1,n2/))

                         !deallocate(rt_adj)

                         allocate (rt_adj_cmp2D(n1,n2))
                         rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
                         ! rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
                         ! rt_adj_cmp2D(n1+1:n1*2,1:n2*2)= rt_adj_cmp2D(n1:1:-1,1:n2*2)

                         deallocate(rt_adj_2D)
                         !n2=n2*2
                         !n1=n1*2



                         !       write(0,*) 'initializing FFTW'
                         ! INITIALIZE FFTW
                         !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
                         fft_2d_id  =init_fft_2d (n1 ,n2)  
                         !       write(0,*) 'after fft init',n1,n2,n3
                         ! APPLY FFTW
                         ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
                         call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
                         call clean_fft(fft_2d_id)
                         !     write(0,*) 'after fft'

                         allocate(OutY(n1,n2))
                         OutY=0.

                         ! where (real(ztrans(1,:,:))/=0.) OutY=rt_adj_cmp2D/ztrans(1,:,:)
                         !  where (ztrans(1,:,:)/=0.) OutY=(rt_adj_cmp2D*ztrans(1,:,:))/(ztrans(1,:,:)*ztrans(1,:,:)+.000000001)
                         !  where (real(ztrans(1,:,:))>.00001) OutY=(rt_adj_cmp2D*ztrans(1,:,:))/(ztrans(1,:,:)*ztrans(1,:,:)+.000000001)
                         where (real(ztrans(1,:,:))>.00001) OutY=(rt_adj_cmp2D)/(ztrans(1,:,:))
                            !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

                            deallocate(rt_adj_cmp2D)

                            ! INVERSE FFTW
                            fft_2d_id  =init_fft_2d (n1 ,n2)  
                            call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
                            call clean_fft(fft_2d_id)
                            !    write(0,*) 'after inverse fft'
                            !  n2=n2/2
                            !  n1=n1/2
                            allocate(Outphase(n1,n2))

                            Outphase=real(OutY(1:n1,1:n2))

                            deallocate(OutY)

                            ! RESHAPE OUTPUT TO hh
                            hh=reshape(Outphase,(/size(Outphase)/))

                            deallocate(Outphase)
                          end subroutine dipintegrate_timeslice_nomirror

                          subroutine dipintegrate_full( rt_adj,hh,eps_t,n1,n2,ztrans)
                            integer		       :: n1,n2,n3,stat1,div,mirror_len
                            integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

                            complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
                            complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
                            complex                  :: kern7
                            real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
                            real                     :: eps_t,eps_h
                            double precision         :: pi_var
                            real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
                            real, pointer            :: rt(:),rt_adj(:)
                            real, allocatable        :: FrequRangeZ(:)
                            real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
                            real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
                            complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
                            complex                  :: ztrans(:,:,:)
                            real,    dimension  (2)   :: dot1,dot2

                            type(fft_type)           :: fft_2d_id

                            ! CREATE PI VARIABLE
                            pi_var=acos(-1.)

                            ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
                            n3=1
                            !   call igrad2_3d_init(n1,n2,n3,eps_h)
                            ! call igrad2_2d_init(n1,n2)
                            !  allocate( rt_adj(n1*n2))
                            !call dot_test (igrad2_2d_lop,100,100,dot1,dot2)
                            write(0,*) 'here'
                            ! APPLY DIVERGENCE   
                            ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 




                            ! stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)

!!$                            call sep_write (rt_adj,"test")
!!$                            call to_history ("n1",   n1,"test")
!!$                            call to_history ("n2",   n2,"test")
                            ! RESHAPE TO 3D
                            !  deallocate(rt)
                            allocate ( rt_adj_2D(n1,n2) )

                            rt_adj_2D=reshape(rt_adj,(/n1,n2/))

                            !   deallocate(rt_adj)

                            allocate (rt_adj_cmp2D(n1,n2*2))
                            rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
                            ! rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
                            rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
                            deallocate(rt_adj_2D)
                            n2=n2*2



                            write(0,*) 'initializing FFTW'
                            ! INITIALIZE FFTW
                            !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
                            fft_2d_id  =init_fft_2d (n1 ,n2)  
                            write(0,*) 'after fft init',n1,n2,n3
                            ! APPLY FFTW
                            ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
                            call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
                            call clean_fft(fft_2d_id)
                            write(0,*) 'after fft'

                            allocate(OutY(n1,n2))
                            OutY=0.

                            where (real(ztrans(:,:,1))/=0.) OutY=rt_adj_cmp2D/ztrans(:,:,1)
                               !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

                               deallocate(rt_adj_cmp2D)

                               ! INVERSE FFTW
                               fft_2d_id  =init_fft_2d (n1 ,n2)  
                               call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
                               call clean_fft(fft_2d_id)
                               write(0,*) 'after inverse fft'
                               n2=n2/2
                               allocate(Outphase(n1,n2))

                               Outphase=real(OutY(1:n1,1:n2))

                               deallocate(OutY)

                               ! RESHAPE OUTPUT TO hh
                               hh=reshape(Outphase,(/size(Outphase)/))

                               deallocate(Outphase)
                             end subroutine dipintegrate_full


                             subroutine correct_dip_1D(tau,px,px_new,ref_2,it)
                               ! Pass a 1D tau and calculate   px(tau)-grad tau=px_new
                               integer		       :: n1,n2,n3,tau_1,tau_2,ref_2
                               integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
                               real		       :: tau(:),px(:,:,:),upwt,downwt,p_tau,dtau_dx
                               real                    :: px_new(:,:,:),shift_var
                               real, allocatable       ::tau_2D(:,:)
                               !    write(0,*) 'correcting dips'
                               n1=size(px(:,1,1))
                               n2=size(px(1,:,1))
                               px_new=0.
                               ! FOR EACH POINT IN TAU SAMPLE THE PX FIELD AND SUBTRACT dtau/dx
                               do ix=1,n2-1
                                  shift_var=tau(ix)-tau(ref_2)
                                  tau_1=floor(it+shift_var)
                                  tau_2=ceiling(it+shift_var)
                                  upwt=it+shift_var-tau_1
                                  downwt=1.-upwt
                                  if (tau_1>=1.AND.tau_2<=n1) then
                                     p_tau=downwt*px(tau_1,ix,1)+upwt*px(tau_2,ix,1)
                                     dtau_dx=tau(ix+1)-tau(ix)
                                     px_new(1,ix,1)=p_tau-dtau_dx
                                  end if
                               end do
                             end subroutine correct_dip_1D



                             subroutine correct_dip_2D(tau,px,px_new,ref_2)
                               integer		       :: n1,n2,n3,tau_1,tau_2,ref_2
                               integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
                               real		       :: tau(:),px(:,:,:),upwt,downwt,p_tau,dtau_dx
                               real                    :: px_new(:,:,:),shift_var
                               real, allocatable       ::tau_2D(:,:)
                               !    write(0,*) 'correcting dips'
                               n1=size(px(:,1,1))
                               n2=size(px(1,:,1))
                               allocate(tau_2D(n1,n2))
                               tau_2D=reshape(tau,(/n1,n2/))
                               !     write(0,*) 'n1,n2',n1,n2,ref_2
                               px_new=0.
                               ! FOR EACH POINT IN TAU SAMPLE THE PX FIELD AND SUBTRACT dtau/dx
                               do it=1,n1
                                  do ix=1,n2-1
                                     shift_var=tau_2D(it,ix)-tau_2D(it,ref_2)
                                     tau_1=floor(it+shift_var)
                                     tau_2=ceiling(it+shift_var)
                                     upwt=it+shift_var-tau_1
                                     downwt=1.-upwt
                                     if (tau_1>=1.AND.tau_2<=n1) then
                                        p_tau=downwt*px(tau_1,ix,1)+upwt*px(tau_2,ix,1)
                                        dtau_dx=tau_2D(it,ix+1)-tau_2D(it,ix)
                                        px_new(it,ix,1)=p_tau-dtau_dx
                                     end if
                                     !        if (tau_1<1.or.tau_2>n1) px_new(it,ix,1)=0.

                                  end do
                               end do
                               !    write(0,*) 'CORRECTED THE DIP'
                               deallocate(tau_2D)
                             end subroutine correct_dip_2D

                             subroutine correct_dip_2D_reg(tau,px,px_new,ref_2)
                               integer		       :: n1,n2,n3,tau_1,tau_2,ref_2
                               integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
                               real		       :: tau(:),px(:,:,:),upwt,downwt,p_tau,dtau_dx
                               real                    :: px_new(:,:,:),shift_var
                               real, allocatable       ::tau_2D(:,:)
                               !    write(0,*) 'correcting dips'
                               n1=size(px(:,1,1))
                               n2=size(px(1,:,1))
                               allocate(tau_2D(n1,n2))
                               tau_2D=reshape(tau,(/n1,n2/))
                               !     write(0,*) 'n1,n2',n1,n2,ref_2
                               px_new=0.
                               ! FOR EACH POINT IN TAU SAMPLE THE PX FIELD AND SUBTRACT dtau/dx
                               do it=1,n1
                                  do ix=1,n2-1
                                     shift_var=tau_2D(it,ix)-tau_2D(it,ref_2)
                                     tau_1=floor(it+shift_var)
                                     tau_2=ceiling(it+shift_var)
                                     upwt=it+shift_var-tau_1
                                     downwt=1.-upwt
                                     if (tau_1>=1.AND.tau_2<=n1) then
                                        p_tau=downwt*px(tau_1,ix,1)+upwt*px(tau_2,ix,1)
                                        dtau_dx=tau_2D(it,ix+1)-tau_2D(it,ix)
                                        px_new(it,ix,1)=p_tau-dtau_dx
                                     end if
                                     !        if (tau_1<1.or.tau_2>n1) px_new(it,ix,1)=0.

                                  end do
                               end do
                               !    write(0,*) 'CORRECTED THE DIP'
                               deallocate(tau_2D)
                             end subroutine correct_dip_2D_reg
                             subroutine correct_div(tau,pterm,pterm_cor)
                               integer		       :: n1,n2,n3,tau_1,tau_2
                               integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
                               real		       :: tau(:),pterm(:,:),pterm_cor(:,:),upwt,downwt,p1_tau,p2_tau,dtau_dx
                               real                    :: shift_var,shift_var2
                               real, allocatable       ::tau_2D(:,:)
                               write(0,*) 'correcting dips'
                               n1=size(pterm(:,1))
                               n2=size(pterm(1,:))
                               allocate(tau_2D(n1,n2))
                               tau_2D=reshape(tau,(/n1,n2/))
                               write(0,*) 'n1,n2',n1,n2
                               pterm_cor=0.
                               ! SAMPLE PTERM AT TAU
                               do it=1,n1
                                  do ix=1,n2-1
                                     shift_var=tau_2D(it,ix)-tau_2D(it,1)
                                     tau_1=floor(it+shift_var)
                                     tau_2=ceiling(it+shift_var)
                                     upwt=it+shift_var-tau_1
                                     downwt=1.-upwt
                                     p1_tau=downwt*pterm(tau_1,ix)+upwt*pterm(tau_2,ix)
                                     dtau_dx=tau_2D(it,ix+1)-tau_2D(it,ix)
                                     !write(0,*) 'dtau_dx',tau_2D(it+1,ix+1)-tau_2D(it,ix)
!!$                shift_var2=tau_2D(it+1,ix)-tau_2D(it+1,1)
!!$                dtau_dx=shift_var2-shift_var
!!$
!!$                tau_1=floor(it+shift_var2)
!!$                tau_2=ceiling(it+shift_var2)
!!$                upwt=it+shift_var2-tau_1
!!$                downwt=1.-upwt
!!$                p2_tau=downwt*pterm(tau_1,ix)+upwt*pterm(tau_2,ix)

                                     pterm_cor(it,ix)=p1_tau
!!$      pterm_cor(it,ix)=.5* (p2_tau-p1_tau)/dtau_dx
!!$if (dtau_dx<.001) pterm_cor(it,ix)=0.
                                     if (tau_1<1.or.tau_2>n1) pterm_cor(it,ix)=0.
                                  end do
                               end do
                               deallocate(tau_2D)
                             end subroutine correct_div

                             subroutine correct_dip_3D(tau,p,p_new,n1,n2,n3,ref_2,ref_3)
                               integer		       :: n1,n2,n3,tau_1,tau_2,ref_2,ref_3
                               integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
                               real		       :: tau(:),upwt,downwt,p_tau_x,p_tau_y,dtau_dx,dtau_dy
                               real                    :: shift_var,p(:),p_new(:)
                               real, allocatable       ::tau_3D(:,:,:),px_3D(:,:,:),py_3D(:,:,:)
                               real, allocatable       ::px_3D_new(:,:,:),py_3D_new(:,:,:)
                               write(0,*) 'correcting dips'
                               ! n1=size(px(:,1,1))
                               ! n2=size(px(1,:,1))

                               allocate(tau_3D(n1,n2,n3),px_3D(n1,n2,n3),py_3D(n1,n2,n3))
                               allocate(px_3D_new(n1,n2,n3),py_3D_new(n1,n2,n3))

                               tau_3D=reshape(tau,(/n1,n2,n3/))
                               px_3D=reshape(p(1:n1*n2*n3),(/n1,n2,n3/))
                               py_3D=reshape(p(n1*n2*n3+1:2*n1*n2*n3),(/n1,n2,n3/))
                               write(0,*) 'n1,n2,n3',n1,n2,n3
                               p_new=0.
                               px_3D_new=0.
                               py_3D_new=0.
                               ! FOR EACH POINT IN TAU SAMPLE THE PX FIELD AND SUBTRACT dtau/dx
                               do it=1,n1
                                  do ix=1,n2-1
                                     do iy=1,n3-1
                                        shift_var=tau_3D(it,ix,iy)-tau_3D(it,ref_2,ref_3)
                                        tau_1=floor(it+shift_var)
                                        tau_2=ceiling(it+shift_var)
                                        upwt=it+shift_var-tau_1
                                        downwt=1.-upwt
                                        if (tau_1>=1.AND.tau_2<=n1) then
                                           p_tau_x=downwt*px_3D(tau_1,ix,iy)+upwt*px_3D(tau_2,ix,iy)
                                           p_tau_y=downwt*py_3D(tau_1,ix,iy)+upwt*py_3D(tau_2,ix,iy)

!!$                   if (tau_1<=n1.and.tau_2>n1) then
!!$                      p_tau_x=px_3D(tau_1,ix,iy)
!!$                      p_tau_y=py_3D(tau_1,ix,iy)
!!$                   end if
!!$                   if (tau_1<1..and.tau_2>=1.) then
!!$                      p_tau_x=px_3D(tau_2,ix,iy)
!!$                      p_tau_y=py_3D(tau_2,ix,iy)
!!$                   end if


                                           ! p_tau_x=px_3D(it,ix,iy)
                                           ! p_tau_y=py_3D(it,ix,iy)
                                           dtau_dx=tau_3D(it,ix+1,iy)-tau_3D(it,ix,iy)
                                           dtau_dy=tau_3D(it,ix,iy+1)-tau_3D(it,ix,iy)

                                           px_3D_new(it,ix,iy)=p_tau_x-dtau_dx
                                           py_3D_new(it,ix,iy)=p_tau_y-dtau_dy
                                        end if
                                        !              if (tau_2<1.or.tau_1>n1) then
                                        !                 px_3D_new(it,ix,iy)=0.
                                        !                 py_3D_new(it,ix,iy)=0.
                                        !              end if

                                     end do
                                  end do
                               end do

                               p_new(1:n1*n2*n3)=reshape(px_3D_new,(/n1*n2*n3/))
                               p_new(n1*n2*n3+1:2*n1*n2*n3)=reshape(py_3D_new,(/n1*n2*n3/))
                               deallocate(tau_3D,px_3D,py_3D)
                               deallocate(px_3D_new,py_3D_new)
                             end subroutine correct_dip_3D


                             subroutine p_at_tau(tau,p,p_new,n1,n2,n3,ref_2,ref_3)
                               integer		       :: n1,n2,n3,tau_1,tau_2,ref_2,ref_3
                               integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
                               real		       :: tau(:),upwt,downwt,p_tau_x,p_tau_y,dtau_dx,dtau_dy
                               real                    :: shift_var,p(:),p_new(:)
                               real, allocatable       ::tau_3D(:,:,:),px_3D(:,:,:),py_3D(:,:,:)
                               real, allocatable       ::px_3D_new(:,:,:),py_3D_new(:,:,:)
                               write(0,*) 'correcting dips'
                               ! n1=size(px(:,1,1))
                               ! n2=size(px(1,:,1))

                               allocate(tau_3D(n1,n2,n3),px_3D(n1,n2,n3),py_3D(n1,n2,n3))
                               allocate(px_3D_new(n1,n2,n3),py_3D_new(n1,n2,n3))

                               tau_3D=reshape(tau,(/n1,n2,n3/))
                               px_3D=reshape(p(n1*n2*n3+1:n1*n2*n3*2),(/n1,n2,n3/))
                               py_3D=reshape(p(n1*n2*n3*2+1:3*n1*n2*n3),(/n1,n2,n3/))
                               write(0,*) 'n1,n2,n3',n1,n2,n3
                               p_new=0.
                               px_3D_new=0.
                               py_3D_new=0.
                               ! FOR EACH POINT IN TAU SAMPLE THE PX FIELD AND SUBTRACT dtau/dx
                               do it=1,n1
                                  do ix=1,n2-1
                                     do iy=1,n3-1
                                        shift_var=tau_3D(it,ix,iy)-tau_3D(it,ref_2,ref_3)
                                        tau_1=floor(it+shift_var)
                                        tau_2=ceiling(it+shift_var)
                                        upwt=it+shift_var-tau_1
                                        downwt=1.-upwt
                                        if (tau_1>=1.AND.tau_2<=n1) then
                                           p_tau_x=downwt*px_3D(tau_1,ix,iy)+upwt*px_3D(tau_2,ix,iy)
                                           p_tau_y=downwt*py_3D(tau_1,ix,iy)+upwt*py_3D(tau_2,ix,iy)

!!$                   if (tau_1<=n1.and.tau_2>n1) then
!!$                      p_tau_x=px_3D(tau_1,ix,iy)
!!$                      p_tau_y=py_3D(tau_1,ix,iy)
!!$                   end if
!!$                   if (tau_1<1..and.tau_2>=1.) then
!!$                      p_tau_x=px_3D(tau_2,ix,iy)
!!$                      p_tau_y=py_3D(tau_2,ix,iy)
!!$                   end if


                                           ! p_tau_x=px_3D(it,ix,iy)
                                           ! p_tau_y=py_3D(it,ix,iy)
                                           !   dtau_dx=tau_3D(it,ix+1,iy)-tau_3D(it,ix,iy)
                                           !   dtau_dy=tau_3D(it,ix,iy+1)-tau_3D(it,ix,iy)

                                           px_3D_new(it,ix,iy)=p_tau_x !-dtau_dx
                                           py_3D_new(it,ix,iy)=p_tau_y !-dtau_dy
                                        end if
                                        !              if (tau_2<1.or.tau_1>n1) then
                                        !                 px_3D_new(it,ix,iy)=0.
                                        !                 py_3D_new(it,ix,iy)=0.
                                        !              end if

                                     end do
                                  end do
                               end do

                               p_new(n1*n2*n3+1:n1*n2*n3*2)=reshape(px_3D_new,(/n1*n2*n3/))
                               p_new(n1*n2*n3*2+1:n1*n2*n3*3)=reshape(py_3D_new,(/n1*n2*n3/))
                               deallocate(tau_3D,px_3D,py_3D)
                               deallocate(px_3D_new,py_3D_new)
                             end subroutine p_at_tau

                             subroutine p_at_tau2D(tau,p,p_new,n1,n2,ref_2)
                               integer		       :: n1,n2,n3,tau_1,tau_2,ref_2
                               integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
                               real		       :: tau(:),upwt,downwt,p_tau_x,p_tau_y,dtau_dx,dtau_dy
                               real                    :: shift_var,p(:),p_new(:)
                               real, allocatable       ::tau_3D(:,:,:),px_3D(:,:,:),py_3D(:,:,:)
                               real, allocatable       ::px_3D_new(:,:,:),py_3D_new(:,:,:)
                               write(0,*) 'correcting dips'
                               ! n1=size(px(:,1,1))
                               ! n2=size(px(1,:,1))
                               n3=1
                               allocate(tau_3D(n1,n2,n3),px_3D(n1,n2,n3))!,py_3D(n1,n2,n3))
                               allocate(px_3D_new(n1,n2,n3)) !,py_3D_new(n1,n2,n3))

                               tau_3D=reshape(tau,(/n1,n2,n3/))
                               px_3D=reshape(p(n1*n2*n3+1:n1*n2*n3*2),(/n1,n2,n3/))
                               ! py_3D=reshape(p(n1*n2*n3*2+1:3*n1*n2*n3),(/n1,n2,n3/))
                               write(0,*) 'n1,n2,n3',n1,n2,n3
                               p_new=0.
                               px_3D_new=0.
                               !   py_3D_new=0.
                               ! FOR EACH POINT IN TAU SAMPLE THE PX FIELD AND SUBTRACT dtau/dx
                               do it=1,n1
                                  do ix=1,n2-1
                                     !   do iy=1,n3-1
                                     iy=1
                                     shift_var=tau_3D(it,ix,iy)-tau_3D(it,ref_2,1)
                                     tau_1=floor(it+shift_var)
                                     tau_2=ceiling(it+shift_var)
                                     upwt=it+shift_var-tau_1
                                     downwt=1.-upwt
                                     if (tau_1>=1.AND.tau_2<=n1) then
                                        p_tau_x=downwt*px_3D(tau_1,ix,iy)+upwt*px_3D(tau_2,ix,iy)
                                        !p_tau_y=downwt*py_3D(tau_1,ix,iy)+upwt*py_3D(tau_2,ix,iy)

!!$                   if (tau_1<=n1.and.tau_2>n1) then
!!$                      p_tau_x=px_3D(tau_1,ix,iy)
!!$                      p_tau_y=py_3D(tau_1,ix,iy)
!!$                   end if
!!$                   if (tau_1<1..and.tau_2>=1.) then
!!$                      p_tau_x=px_3D(tau_2,ix,iy)
!!$                      p_tau_y=py_3D(tau_2,ix,iy)
!!$                   end if


                                        ! p_tau_x=px_3D(it,ix,iy)
                                        ! p_tau_y=py_3D(it,ix,iy)
                                        !   dtau_dx=tau_3D(it,ix+1,iy)-tau_3D(it,ix,iy)
                                        !   dtau_dy=tau_3D(it,ix,iy+1)-tau_3D(it,ix,iy)

                                        px_3D_new(it,ix,iy)=p_tau_x !-dtau_dx
                                        !  py_3D_new(it,ix,iy)=p_tau_y !-dtau_dy
                                     end if
                                     !              if (tau_2<1.or.tau_1>n1) then
                                     !                 px_3D_new(it,ix,iy)=0.
                                     !                 py_3D_new(it,ix,iy)=0.
                                     !              end if

                                  end do
                               end do


                               p_new(n1*n2*n3+1:n1*n2*n3*2)=reshape(px_3D_new,(/n1*n2*n3/))
                               !  p_new(n1*n2*n3*2+1:n1*n2*n3*3)=reshape(py_3D_new,(/n1*n2*n3/))
                               deallocate(tau_3D,px_3D)
                               deallocate(px_3D_new)
                             end subroutine p_at_tau2D



                             subroutine correct_dip_timeslice(tau,p,p_new,n1,n2,n3,ref_2,ref_3,it)
                               integer		       :: n1,n2,n3,tau_1,tau_2,ref_2,ref_3
                               integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
                               real		       :: tau(:),upwt,downwt,p_tau_x,p_tau_y,dtau_dx,dtau_dy
                               real                    :: shift_var,p(:),p_new(:)
                               real, allocatable       ::tau_2D(:,:),px_3D(:,:,:),py_3D(:,:,:)
                               real, allocatable       ::px_2D_new(:,:),py_2D_new(:,:)
                               !      write(0,*) 'correcting dips',n1,n2,n3
                               ! n1=size(px(:,1,1))
                               ! n2=size(px(1,:,1))

                               allocate(tau_2D(n2,n3),px_3D(n1,n2,n3),py_3D(n1,n2,n3))
                               allocate(px_2D_new(n2,n3),py_2D_new(n2,n3))

                               tau_2D=reshape(tau,(/n2,n3/))

                               px_3D=reshape(p(1:n1*n2*n3),(/n1,n2,n3/))

                               py_3D=reshape(p(n1*n2*n3+1:2*n1*n2*n3),(/n1,n2,n3/))

                               !    write(0,*) 'n1,n2,n3',n1,n2,n3
                               p_new=0.

                               ! FOR EACH POINT IN TAU SAMPLE THE PX FIELD AND SUBTRACT dtau/dx
                               !   do it=1,n1
                               do ix=1,n2-1
                                  do iy=1,n3-1
                                     shift_var=tau_2D(ix,iy)-tau_2D(ref_2,ref_3)
                                     tau_1=floor(it+shift_var)
                                     tau_2=ceiling(it+shift_var)
                                     upwt=it+shift_var-tau_1
                                     downwt=1.-upwt
                                     p_tau_x=downwt*px_3D(tau_1,ix,iy)+upwt*px_3D(tau_2,ix,iy)
                                     p_tau_y=downwt*py_3D(tau_1,ix,iy)+upwt*py_3D(tau_2,ix,iy)
                                     ! p_tau_x=px_3D(it,ix,iy)
                                     ! p_tau_y=py_3D(it,ix,iy)
                                     dtau_dx=tau_2D(ix+1,iy)-tau_2D(ix,iy)
                                     dtau_dy=tau_2D(ix,iy+1)-tau_2D(ix,iy)

                                     px_2D_new(ix,iy)=p_tau_x-dtau_dx
                                     py_2D_new(ix,iy)=p_tau_y-dtau_dy
!!$     if (tau_1<1.or.tau_2>n1) then 
!!$        px_2D_new(ix,iy)=0. 
!!$        py_2D_new(ix,iy)=0.
!!$end if  
                                  end do
                               end do
                               !  end do

                               p_new(1:n2*n3)=reshape(px_2D_new,(/n2*n3/))
                               p_new(n2*n3+1:2*n2*n3)=reshape(py_2D_new,(/n2*n3/))
                               deallocate(tau_2D,px_3D,py_3D)
                               deallocate(px_2D_new,py_2D_new)
                             end subroutine correct_dip_timeslice

                             subroutine cube_tau_sample(p_3D,tau,p_new,n1,n2,n3,ref_2,ref_3,it)
                               ! pass it a 3D cube and a tau slice(:) and sample from that cube
                               integer		       :: n1,n2,n3,tau_1,tau_2,ref_2,ref_3
                               integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
                               real		       :: tau(:),upwt,downwt,p_tau_x,p_tau_y,dtau_dx,dtau_dy
                               real                    :: shift_var,p_new(:)
                               real, allocatable       ::tau_2D(:,:),py_3D(:,:,:)
                               real                    ::p_3D(:,:,:)
                               real, allocatable       ::p_2D_new(:,:)
                               !    write(0,*) 'correcting dips'


                               allocate(tau_2D(n2,n3))
                               allocate(p_2D_new(n2,n3))

                               tau_2D=reshape(tau,(/n2,n3/))

                               !  write(0,*) 'n1,n2,n3',n1,n2,n3
                               p_new=0.
                               p_2D_new=0.

                               do ix=1,n2-1
                                  do iy=1,n3-1
                                     shift_var=tau_2D(ix,iy)-tau_2D(ref_2,ref_3)
                                     tau_1=floor(it+shift_var)
                                     tau_2=ceiling(it+shift_var)
                                     upwt=it+shift_var-tau_1
                                     downwt=1.-upwt
                                     if (tau_1>=1.AND.tau_2<=n1) then
                                        p_2D_new(ix,iy)=downwt*p_3D(tau_1,ix,iy)+upwt*p_3D(tau_2,ix,iy)


                                     end if

                                  end do
                               end do


                               p_new(1:n2*n3)=reshape(p_2D_new,(/n2*n3/))

                               deallocate(tau_2D)
                               deallocate(p_2D_new)
                             end subroutine cube_tau_sample

                             subroutine section_tau_sample(p_3D,tau,p_new,n1,n2,ref_2,it)
                               ! pass it a 3D cube and a tau slice(:) and sample from that cube
                               integer		       :: n1,n2,n3,tau_1,tau_2,ref_2,ref_3
                               integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
                               real		       :: tau(:),upwt,downwt,p_tau_x,p_tau_y,dtau_dx,dtau_dy
                               real                    :: shift_var,p_new(:)
                               real, allocatable       ::tau_2D(:,:),py_3D(:,:,:)
                               real                    ::p_3D(:,:,:)
                               real, allocatable       ::p_2D_new(:,:)
                               !    write(0,*) 'correcting dips'


                               allocate(tau_2D(n2,1))
                               allocate(p_2D_new(n2,1))

                               tau_2D=reshape(tau,(/n2,1/))

                               !  write(0,*) 'n1,n2,n3',n1,n2,n3
                               p_new=0.
                               p_2D_new=0.

                               do ix=1,n2-1

                                  shift_var=tau_2D(ix,1)-tau_2D(ref_2,1)
                                  tau_1=floor(it+shift_var)
                                  tau_2=ceiling(it+shift_var)
                                  upwt=it+shift_var-tau_1
                                  downwt=1.-upwt
                                  if (tau_1>=1.AND.tau_2<=n1) then
                                     p_2D_new(ix,1)=downwt*p_3D(tau_1,ix,1)+upwt*p_3D(tau_2,ix,1)


                                  end if


                               end do


                               p_new(1:n2)=reshape(p_2D_new,(/n2/))

                               deallocate(tau_2D)
                               deallocate(p_2D_new)
                             end subroutine section_tau_sample


                             subroutine dipintegrate_2D_section( rt_adj,hh,eps_t,n1,n2,ztrans)
                               integer		       :: n1,n2,n3,stat1,div,mirror_len
                               integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

                               complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
                               complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
                               complex                  :: kern7
                               real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
                               real                     :: eps_t,eps_h
                               double precision         :: pi_var
                               real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
                               real, pointer            :: rt(:),rt_adj(:)
                               real, allocatable        :: FrequRangeZ(:)
                               real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
                               real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
                               complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
                               complex                  :: ztrans(:,:,:)
                               real,    dimension  (2)   :: dot1,dot2

                               type(fft_type)           :: fft_2d_id

                               ! CREATE PI VARIABLE
                               pi_var=acos(-1.)

                               ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
                               n3=1
                               !   call igrad2_3d_init(n1,n2,n3,eps_h)
                               ! call igrad2_2d_init(n1,n2)
                               !  allocate( rt_adj(n1*n2))
                               !call dot_test (igrad2_2d_lop,100,100,dot1,dot2)

                               ! APPLY DIVERGENCE   
                               ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 




                               !  stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)
!!$
!!$    call sep_write (rt_adj,"test")
!!$    call to_history ("n1",   n1,"test")
!!$    call to_history ("n2",   n2,"test")
                               ! RESHAPE TO 3D
                               !   deallocate(rt)
                               allocate ( rt_adj_2D(n1,n2) )

                               rt_adj_2D=reshape(rt_adj,(/n1,n2/))

                               !   deallocate(rt_adj)

                               allocate (rt_adj_cmp2D(n1,n2*2))
                               rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
                               ! rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
                               rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
                               deallocate(rt_adj_2D)
                               n2=n2*2



                               !    write(0,*) 'initializing FFTW'
                               ! INITIALIZE FFTW
                               !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
                               fft_2d_id  =init_fft_2d (n1 ,n2)  
                               !    write(0,*) 'after fft init',n1,n2,n3
                               ! APPLY FFTW
                               ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
                               call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
                               call clean_fft(fft_2d_id)
                               !         write(0,*) 'after fft'

                               allocate(OutY(n1,n2))
                               OutY=0.

                               where (real(ztrans(:,:,1))/=0.) OutY=rt_adj_cmp2D/ztrans(:,:,1)
                                  !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

                                  deallocate(rt_adj_cmp2D)

                                  ! INVERSE FFTW
                                  fft_2d_id  =init_fft_2d (n1 ,n2)  
                                  call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
                                  call clean_fft(fft_2d_id)
                                  write(0,*) 'after inverse fft'
                                  n2=n2/2
                                  allocate(Outphase(n1,n2))

                                  Outphase=real(OutY(1:n1,1:n2))

                                  deallocate(OutY)

                                  ! RESHAPE OUTPUT TO hh
                                  hh=reshape(Outphase,(/size(Outphase)/))

                                  deallocate(Outphase)
                                end subroutine dipintegrate_2D_section 

                              end module dipinteg_3D_2
