module dipinteg_full
  use cgstep_mod
  use sep
  use igrad3_period_eps
  !  use igrad3_2
  use solver_smp_mod
  use fft_data_mod
  !  use change_jl
  use dottest
  !  use flat_mod
  use igrad2_3d
  use igrad2_2d
  use igrad2


  implicit none
contains

  subroutine fullintegrate_2D( rt,hh,eps_t,n1,n2,ztrans)
    integer		       :: n1,n2,n3,stat1,div,mirror_len
    integer                  :: it,i1,i2,i3,ir,ix,iy,taper_len,dist

    complex		       ::Ztrans1, Ztrans2,Ztrans3,Ztrans4,Ztrans5,Ztrans6
    complex                  :: Ztrans7,SumZtrans,kern1,kern2,kern3,kern4,kern5,kern6
    complex                  :: kern7
    real		       :: hh(:),delx,dely,delz,kx,ky,kz,kernval1
    real                     :: eps_t,eps_h
    double precision         :: pi_var
    real, allocatable        :: FrequRangeX(:), FrequRangeY(:)
    real, pointer            :: rt(:),rt_adj(:)
    real, allocatable        :: FrequRangeZ(:)
    real, allocatable        :: Outphase(:,:), rt_adj_2D(:,:),rt_adj_tap(:,:,:),diverg(:,:,:),rt_adj_sub(:,:,:)
    real, allocatable        ::subxy(:,:,:),subx(:,:,:),suby(:,:,:)
    complex, allocatable     :: OutY(:,:),rt_adj_cmp2D(:,:)
    complex                  :: ztrans(:,:,:)
    real,    dimension  (2)   :: dot1,dot2

    type(fft_type)           :: fft_2d_id

    ! CREATE PI VARIABLE
    pi_var=acos(-1.)

    ! INITIALIZE DIVERGENCE-GRADIENT OPERATOR
    n3=1
    !   call igrad2_3d_init(n1,n2,n3,eps_h)
    call igrad2_2d_init(n1,n2)
    allocate( rt_adj(n1*n2))
    !call dot_test (igrad2_2d_lop,100,100,dot1,dot2)
    write(0,*) 'here'
    ! APPLY DIVERGENCE   
    ! stat1=igrad2_3d_lop(.true.,.false.,rt_adj , rt) 




    stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)

    call sep_write (rt_adj,"test")
    call to_history ("n1",   n1,"test")
    call to_history ("n2",   n2,"test")
    ! RESHAPE TO 3D
    !   deallocate(rt)
    allocate ( rt_adj_2D(n1,n2) )

    rt_adj_2D=reshape(rt_adj,(/n1,n2/))

    deallocate(rt_adj)

    allocate (rt_adj_cmp2D(n1,n2*2))
    rt_adj_cmp2D(1:n1,1:n2)         = cmplx(rt_adj_2D(1:n1,1:n2),0.)
    ! rt_adj_cmp3D(1:n1,1:n2,n3+1:2*n3)  = cmplx(rt_adj_3D(1:n1,1:n2,n3:1:-1),0.)
    rt_adj_cmp2D(1:n1,n2+1:n2*2)= rt_adj_cmp2D(1:n1,n2:1:-1)
    deallocate(rt_adj_2D)
    n2=n2*2



    write(0,*) 'initializing FFTW'
    ! INITIALIZE FFTW
    !   fft_3d_id  =init_fft_3d (n1 ,n2,n3)  
    fft_2d_id  =init_fft_2d (n1 ,n2)  
    write(0,*) 'after fft init',n1,n2,n3
    ! APPLY FFTW
    ! call fft_3d_data(fft_3d_id,FFTW_FORWARD,n1,n2,n3,rt_adj_cmp3D)
    call fft_2d_data(fft_2d_id,FFTW_FORWARD,n1,n2,rt_adj_cmp2D)
    call clean_fft(fft_2d_id)
    write(0,*) 'after fft'

    allocate(OutY(n1,n2))
    OutY=0.

    where (ztrans(:,:,1)/=0.) OutY=rt_adj_cmp2D/ztrans(:,:,1)
       !OutY=(rt_adj_cmp2D*ztrans)/(ztrans*ztrans+.000001)

       deallocate(rt_adj_cmp2D)

       ! INVERSE FFTW
       fft_2d_id  =init_fft_2d (n1 ,n2)  
       call fft_2d_data(fft_2d_id,FFTW_BACKWARD,n1,n2,OutY)
       call clean_fft(fft_2d_id)
       write(0,*) 'after inverse fft'
       n2=n2/2
       allocate(Outphase(n1,n2))

       Outphase=real(OutY(1:n1,1:n2))

       deallocate(OutY)

       ! RESHAPE OUTPUT TO hh
       hh=reshape(Outphase,(/size(Outphase)/))

       deallocate(Outphase)
     end subroutine fullintegrate_2D




!!$     subroutine correct_dip_2D(tau,px,px_new,ref_2)
!!$       integer		       :: n1,n2,n3,tau_1,tau_2,ref_2
!!$       integer                 :: it,i1,i2,i3,ir,ix,iy,taper_len,dist
!!$       real		       :: tau(:),px(:,:,:),upwt,downwt,p_tau,dtau_dx
!!$       real                    :: px_new(:,:,:),shift_var
!!$       real, allocatable       ::tau_2D(:,:)
!!$       write(0,*) 'correcting dips'
!!$       n1=size(px(:,1,1))
!!$       n2=size(px(1,:,1))
!!$       allocate(tau_2D(n1,n2))
!!$       tau_2D=reshape(tau,(/n1,n2/))
!!$       write(0,*) 'n1,n2',n1,n2,ref_2
!!$       px_new=0.
!!$       ! FOR EACH POINT IN TAU SAMPLE THE PX FIELD AND SUBTRACT dtau/dx
!!$       do it=1,n1
!!$          do ix=1,n2-1
!!$             shift_var=tau_2D(it,ix)-tau_2D(it,ref_2)
!!$             tau_1=floor(it+shift_var)
!!$             tau_2=ceiling(it+shift_var)
!!$             upwt=it+shift_var-tau_1
!!$             downwt=1.-upwt
!!$             if (tau_1>=1.AND.tau_2<=n1) then
!!$                p_tau=downwt*px(tau_1,ix,1)+upwt*px(tau_2,ix,1)
!!$                dtau_dx=tau_2D(it,ix+1)-tau_2D(it,ix)
!!$                px_new(it,ix,1)=p_tau-dtau_dx
!!$             end if
!!$             !        if (tau_1<1.or.tau_2>n1) px_new(it,ix,1)=0.
!!$
!!$          end do
!!$       end do
!!$       write(0,*) 'CORRECTED THE DIP'
!!$       deallocate(tau_2D)
!!$     end subroutine correct_dip_2D

   end module dipinteg_full
