module sinc_mod
  ! JESSE LOMASK 6/05/2005

  use iflport
  use sep

  implicit none

contains
  subroutine sinc_tab(table_vec,alpha,sinc_win)
    ! CREATES A TABLE OF SINC COEFFICIENTS   

    real,    dimension (:)     :: table_vec
    real                       ::xmnoN,pi
    integer                    :: N,isinc, sinc_index,xmn,sinc_win
    real                       ::dist,alpha,dist_sinc_win,stddev

    stddev=10.
    pi=acos(-1.)
    N=size(table_vec)

!!$    if (real(N)/2.-floor(real(N)/2.) <.000001) then
!!$       write(0,*) 'SINC WINDOW MUST BE ODD'
!!$       call exit(0)
!!$    end if


    do isinc=1,N
       dist=0+(isinc-1)*((real(sinc_win)/2.+1)/N)

       dist_sinc_win=dist/real(sinc_win)
!!$       sinc_index=-floor(real(N)/2.)+(isinc-1)
       if (dist==0.) then
          table_vec(isinc)=1.
       else
!!$          table_vec(isinc)=sin(pi*real(sinc_index))/\
!!$          (pi*(real(sinc_index)))

          ! sinc_func=sin(pi*dist)*besj0(alpha*((1-dist_sinc_win**2)**.5)) / (pi*dist*besj0(alpha))
          table_vec(isinc)=sin(pi*dist)*2.**(-(dist/stddev)**2.) / (pi*dist)
          !     table_vec(isinc)=sin(pi*dist) / (pi*dist)
       end if

!   write(0,*)isinc, dist,table_vec(isinc)

    end do

    call to_history("n1",N,"junk") !; call to_history("n2",n2,"outwt")
!!$  call to_history("n3",n2,"outwt")
!!$  call to_history("d1",1.0,"outwt"); call to_history("d2",1.0,"outwt")
!!$  call to_history("d3",1.0,"outwt")
!!$  call to_history("o1",0.,"outwt"); call to_history("o2",0.,"outwt")
!!$  call to_history("o3",0.,"outwt")
!!$  call to_history("esize",4,"outwt")
    call sep_write(table_vec,"junk")

  end subroutine sinc_tab

  real function sinc_func(dist,alpha,sinc_win)
    ! PASS IT A DISTANCE FROM CENTER OF SINC FUNCTION AND IT RETURNS THE AMPLITUDE

    integer                    :: N,isinc, sinc_index,xmn,sinc_win
    real                       ::dist,pi,alpha,dist_sinc_win,stddev

    stddev=10
    dist_sinc_win=dist/real(sinc_win)

    pi=acos(-1.)
    if (dist==0.) then
       sinc_func=1.
    else
       ! sinc_func=sin(pi*dist)*besj0(alpha*((1-dist_sinc_win**2)**.5)) / (pi*dist*besj0(alpha))
       sinc_func=sin(pi*dist)*2**(-(dist/stddev)**2) / (pi*dist)
       !sinc_func=sin(pi*dist) / (pi*dist)

    end if

  end function sinc_func

end module sinc_mod
